// Ionic Starter App
// angular.module is a global place for creating, registering and retrieving Angular modules
// 'starter' is the name of this angular module example (also set in a <body> attribute in index.html)
// the 2nd parameter is an array of 'requires'
// 'starter.controllers' is found in controllers.js
angular.module('starter', ['ionic', 'ionic.cloud', 'ionic.closePopup', 'starter.services', 'starter.controllers', 'starter.factory', 'starter.filter', 'starter.values', 'starter.constants', 'starter.directive', 'angularMoment', 'ion-floating-menu', 'chart.js', 'ngCordova', 'ionic-toast','cwill747.phonenumber'])
    .run(function($ionicPlatform, $state, $ionicHistory, AuthService, $ionicPopup, $rootScope, _ENV) {
        $ionicPlatform.ready(function() {
            if (typeof gaU !== 'undefined') {
                gaU('create', 'UA-80291819-4', 'auto');
                gaU('set', 'checkProtocolTask', null);
                gaU('set', 'anonymizeIp', true);
                gaU('set', 'forceSSL', true);
            }
            if (window.StatusBar) {
                // org.apache.cordova.statusbar required
                StatusBar.styleDefault();
            }
            // override android back button
            $ionicPlatform.registerBackButtonAction(function(e) {
                if($rootScope.forceUpdateNeeded && !$rootScope.backButtonPressedOnceToExit){//to close app directly when force update is needed
                    $rootScope.backButtonPressedOnceToExit = true;
                    window.plugins.toast.showShortCenter(
                        "Press back button again to exit",
                        function(a) {},
                        function(b) {}
                    );
                    setTimeout(function() {
                        $rootScope.backButtonPressedOnceToExit = false;
                    }, 2000);
                }
                else if ($rootScope.backButtonPressedOnceToExit) {
                    ionic.Platform.exitApp();
                } else if ($ionicHistory.backView()) {
                    $ionicHistory.goBack();
                } else {
                    $rootScope.backButtonPressedOnceToExit = true;
                    window.plugins.toast.showShortCenter(
                        "Press back button again to exit",
                        function(a) {},
                        function(b) {}
                    );
                    setTimeout(function() {
                        $rootScope.backButtonPressedOnceToExit = false;
                    }, 2000);
                }
                e.preventDefault();
                return false;
            }, 101);
            if ((ionic.Platform.isAndroid() || ionic.Platform.isIOS()) && window.cordova && window.navigator.onLine) {
                // deeplink call to initsession from branch.io
                Branch.initSession(function(data) {
                    // read deep link data on click
                    var temp = data.route;
                    window.localStorage.setItem('deeplink_route', temp);
                    if (temp != 'null' && temp != '' && temp != undefined && AuthService.getUserCredentials()) {
                        $ionicHistory.nextViewOptions({
                            disableBack: true
                        });
                        if (temp.indexOf('todos') != -1)
                            $state.go('app.todos');
                        else if (temp.indexOf('contacts') != -1)
                            $state.go('app.contacts');
                        else if (temp.indexOf('calls') != -1)
                            $state.go('app.calls');
                        else if (temp.indexOf('insights') != -1)
                            $state.go('app.insights');
                        else if (temp.indexOf('settings') != -1)
                            $state.go('app.settings');
                    }
                });
            };
        })
    })
    .config(function($stateProvider, $urlRouterProvider, $httpProvider, $ionicConfigProvider, $logProvider, $ionicCloudProvider, $sceDelegateProvider) {
        $sceDelegateProvider.resourceUrlWhitelist([
            // Allow same origin resource loads.
            'self',
            // Allow loading from our assets domain.  Notice the difference between * and **.
            'https://s3.ap-south-1.amazonaws.com/sr-mobile-call-sync/**'
        ]);
        $ionicCloudProvider.init({
            "core": {
                "app_id": "e6e89781"
            }
        });
        $ionicConfigProvider.backButton.text('').icon('ion-chevron-left').previousTitleText(false);
        //$httpProvider.defaults.withCredentials = true;
        $httpProvider.interceptors.push('APIInterceptor');
        $stateProvider
            .state('app', {
                url: '/app',
                abstract: true,
                templateUrl: 'templates/menu.html',
                controller: 'AppCtrl'
            })
            .state('login', {
                url: '/srlogin',
                templateUrl: 'templates/srlogin.html',
                controller: 'SrLoginCtrl'
            })
            .state('onBoard', {
                url: '/onBoard',
                templateUrl: 'templates/onBoard.html',
                controller: 'onBoardCtrl'
            })
            .state('forgotpassword', {
                url: '/forgotpassword',
                templateUrl: 'templates/forgotpassword.html',
                controller: 'frgtCtrl'
            })
            .state('resetpassword', {
                url: '/resetpassword',
                templateUrl: 'templates/resetpassword.html',
                controller: 'resetPasswordCtrl'
            })
            .state('requestdemo', {
                url: '/requestdemo',
                templateUrl: 'templates/requestdemo.html',
                controller: 'requestCtrl'
            })
            .state('forceUpdate', {
                url: '/forceUpdate',
                templateUrl: 'templates/forceUpdate.html'
            })
            .state('requestdemo_success', {
                url: '/requestdemo_success',
                templateUrl: 'templates/requestdemo_success.html'
            })
            .state('requestdemo_failure', {
                url: '/requestdemo_failure',
                templateUrl: 'templates/requestdemo_failure.html'
            })
            .state('phoneverification', {
                url: '/phoneverification',
                templateUrl: 'templates/phoneverification.html',
                controller: 'SrLoginCtrl'
            })
            .state('app.customerdetails', {
                url: '/customerdetails',
                views: {
                    'menuContent': {
                        templateUrl: 'templates/contactdetails.html',
                        controller: 'customerdetailsCtrl'
                    }
                }
            })
            .state('app.newContact', {
                url: '/newContact',
                views: {
                    'menuContent': {
                        templateUrl: 'templates/newContact.html',
                        controller: 'newcontactCtrl'
                    }
                }
            })
            .state('app.help', {
                url: '/help',
                views: {
                    'menuContent': {
                        templateUrl: 'templates/help.html'
                    }
                }
            })
            .state('app.updateContact', {
                url: '/updateContact',
                views: {
                    'menuContent': {
                        templateUrl: 'templates/updateContact.html',
                        controller: 'updateCtrl'
                    }
                }
            })
            .state('app.calls', {
                url: '/calls',
                views: {
                    'menuContent': {
                        templateUrl: 'templates/callslist.html',
                        controller: 'callsCtrl'
                    }
                }
            })
            .state('app.todos', {
                url: '/todos',
                views: {
                    'menuContent': {
                        templateUrl: 'templates/todos.html',
                        controller: 'todosCtrl'
                    }
                }
            })
            .state('signUp', {
                url: '/signUp',
                templateUrl: 'templates/signUp.html',
                controller: 'signUpCtrl'
            })
            .state('validateOTP', {
                url: '/validateOTP',
                templateUrl: 'templates/validateOTP.html',
                controller: 'validateOTPCtrl'
            })
            .state('trial_acc_success', {
                url: '/trial_acc_success',
                templateUrl: 'templates/trial_acc_success.html'
            })
            .state('setPassword', {
                url: '/setPassword',
                templateUrl: 'templates/setpassword.html',
                controller: 'setPasswordCtrl'
            })
            .state('set_password_success', {
                url: '/set_password_success',
                templateUrl: 'templates/set_password_success.html',
            })
            .state('terms_and_conditions', {
                url: '/terms_and_conditions',
                templateUrl: 'templates/termsAndConditions.html',
                controller: 'termsAndConditionsCtrl'
            })
            .state('app.contacts', {
                url: '/contacts',
                views: {
                    'menuContent': {
                        templateUrl: 'templates/contactslist.html',
                        controller: 'contactsCtrl'
                    }
                }
            })
            .state('app.insights', {
                url: '/insights',
                views: {
                    'menuContent': {
                        templateUrl: 'templates/insights.html',
                        controller: 'insightsCtrl'
                    }
                }
            })
             .state('app.accounts', {
                            url: '/accounts',
                            views: {
                                'menuContent': {
                                    templateUrl: 'templates/accounts.html',
                                    controller: 'accountsCtrl'
                                }
                            }
                        })
            .state('app.settings', {
                url: '/settings',
                views: {
                    'menuContent': {
                        templateUrl: 'templates/settings.html',
                        controller: 'settingsCtrl'
                    }
                }
            })
            .state('app.webCallList', {
                url: '/webCallList',
                views: {
                    'menuContent': {
                        templateUrl: 'templates/webCallList.html',
                        controller: 'webCallListCtrl'
                    }
                }
            });
        // if none of the above states are matched, use this as the fallback
        usercred = JSON.parse(window.localStorage.getItem("userCredentials"));
        if (usercred)
            is_owner = usercred.is_owner;
        else
            is_owner = 1;

        // Commenting previous code of default app open
        /*if (is_owner) {
            $urlRouterProvider.otherwise('/app/calls');
        } else {
            $urlRouterProvider.otherwise('/app/todos');
        }*/
        $urlRouterProvider.otherwise('/app/calls');
    });