const { log } = require('gulp-util');

const phoneUtil = require('google-libphonenumber').PhoneNumberUtil.getInstance();

angular.module('starter.controllers', ['ionic.cloud', 'ngCordova.plugins.nativeStorage','ngCordova.plugins.contacts'])
    .run(function($rootScope, $location, $ionicPlatform, AuthService, $window,AppUpdate) {
        // To assign the value console onle
        $rootScope.online = navigator.onLine;

            $window.addEventListener("offline", function() {
                $rootScope.$apply(function() {
                    $rootScope.online = false;
                });
            }, false);

            $window.addEventListener("online", function() {
                $rootScope.$apply(function() {
                    $rootScope.online = true;
                });
            }, false);

            /*
             Log the information of this function
            */
            if($rootScope.allowConsole){
                console.group("Controllers.starter.Info")
                console.info("Console.Status: " + navigator.onLine)
                if($rootScope.online){
                    console.info("Console.online: " + $rootScope.online)
                }else{
                    console.error("Console.Online: " + $rootScope.online)
                }
                console.groupEnd("Controllers.starter.Info")
            }

        // keep user logged in after page refresh
        $ionicPlatform.ready(function() {
        /*
         Allow Console will expose(Display) all the errors and information in console
         To make it easy to debug and understand the background process.

         Note: Keet it true only while debugging, make it false while in production.
        */
        $rootScope.allowConsole = false
            // will execute when device is ready, or immediately if the device is already ready.
            if(window.cordova){
                if(ionic.Platform.isAndroid())
                {
                    if($rootScope.allowConsole){
                        console.group("Controllers.starter.ready")
                        console.info("rootScope.db added")
                        console.groupEnd("Controllers.starter.ready")
                    }
                    $rootScope.db = window.sqlitePlugin.openDatabase({name: "tracking.db", location: 'default',androidDatabaseImplementation: 2});
                    $rootScope.db.transaction(function(tx){
                        tx.executeSql('CREATE TABLE IF NOT EXISTS LoginLogoutTable (login INTEGER, logout INTEGER)');
                    }, function(error) {
                        console.log('Table Creation failed : ' + error.message);
                    }, function() {
                        console.log('table created OK');
                    });

                }
              cordova.getAppVersion.getVersionNumber().then(
                function (version) {
                    $rootScope.appVersion = version;
                  console.log('appVersion', version);
                }
              );
              cordova.getAppVersion.getVersionCode().then(
                function (code) {
                    $rootScope.appVersionCode = code;
                  console.log('appVersionCode', code);
                }
              );
            }
            //checking for app update
            $rootScope.forceUpdateNeeded = false;
            if((ionic.Platform.isIOS()|| ionic.Platform.isAndroid()) && window.cordova){
            console.log("checkUpdate ----- android phone found");
                AppUpdate.checkAppUpdate().then(function(data){
                    console.log("checkUpdate ----- api success");
                    if(data && data.android.stable > $rootScope.appVersionCode){
                        console.log("checkUpdate ----- version exceded");
                        $rootScope.forceUpdateNeeded = true;
                        $location.path('/forceUpdate');
                    }
                },function(error){
                    console.log("checkUpdate ----- api error");
                });
            }
            if(navigator && navigator.splashscreen) navigator.splashscreen.hide();
            var credentials = AuthService.getAuthCredentials();
            if(credentials){
                var promise = AuthService.login(credentials);
                promise.then(function(data){
                },
                function(data){
                    if(data != "No Network"){
                        $rootScope.logout();
                    }
                })
            }
        });

        $rootScope.$on('$locationChangeStart', function(event, next, current) {
            // redirect to login page if not logged in
            var isAuthenticated = AuthService.isAuthenticated();
            if ($location.path() !== '/srlogin' && !isAuthenticated
                && $location.path() !== '/forgotpassword'
                && $location.path() !== '/forceUpdate'
                && $location.path() !== '/requestdemo_success'
                && $location.path() !== '/requestdemo_failure'
                && $location.path() !== '/requestdemo'
                && $location.path() !== '/phoneverification'
                && $location.path() !== '/resetpassword'
                && $location.path() !== '/signUp'
                && $location.path() !== '/validateOTP'
                && $location.path() !== '/trial_acc_success'
                && $location.path() !== '/setPassword'
                && $location.path() !== '/set_password_success') {
                if (window.localStorage.getItem('firstLogin'))
                    $location.path('/srlogin');
                else
                    $location.path('/onBoard');
            }
            if ($location.path() == '/app/calls')
                $rootScope.currently_playingfileevent = false;
            if ($rootScope.media)
                $rootScope.media.release();
        });

        //function to mock back button
        //checks if history is available then go back else take to login page.
        $rootScope.closeRequestDemoModal = function() {
            if(history.length === 1) {
                $window.location.href = '#/srlogin';
            } else {
                history.back();
            }
        };
    })
    .controller('AppCtrl', function($scope, $ionicPlatform, IonicClosePopupService, CallLogService, ionicToast, SaveContact, $location, $timeout, $rootScope, $filter, $ionicLoading, CustomerProfilePic, AuthService, GoogleAnalytics, ClickToCall, $ionicPopup, CustomerData, Loader, $state, $ionicHistory, $ionicPlatform, $ionicModal, countryCodevalues, GetAgents, notification, $window, hotCodeReload, $ionicScrollDelegate,$ionicSideMenuDelegate,AppUpdate,$cordovaContacts, PhonebookContact, $cordovaNativeStorage) {
        var self = this;
        hotCodeReload.checkUpdates();
        // notification.register();
        // $ionicModal.fromTemplateUrl('templates/modal/force-update.html', {
        //             scope: $scope,
        //             animation: 'slide-in-up'
        //           }).then(function(modal) {
        //             $scope.forceUpdateModal = modal;
        // });
        // $scope.openUpdateModal = function() {
        //     console.log("checkUpdate ----- show call");
        //     $scope.isForceUpdateModalOpen = true;
        //     $scope.forceUpdateModal.show();
        // };
        // $scope.closeUpdateModal = function() {
        //     $scope.forceUpdateModal.hide();
        // };

        // Start of C2C dialer controller
        $scope.$watch(function () {
            return $ionicSideMenuDelegate.isOpenLeft();
          },
             function (isOpen) {
            if(isOpen)
                $scope.data.navClose = "button button-icon button-clear ion-ios-close-outline";
            else
                $scope.data.navClose = "button button-icon button-clear ion-navicon";
          });

        $scope.data = {};
        $scope.data.navClose = "button button-icon button-clear ion-navicon";

        $rootScope.activefilters = {};
        $rootScope.mobile = false;
        $scope.data.typedNum = '';
        $scope.countryCodes = countryCodevalues;
        $rootScope.contactActiveFilters = {};

        $scope.form = {};

        //check for the country code based on the country of operation found in login
        var defaultCountryCode = AuthService.getUserCredentials()['default_country_code'];
        var defaultCodeFound = false;
        for (var i = $scope.countryCodes.length - 1; i >= 0; i--) {
            if($scope.countryCodes[i].code == defaultCountryCode){
                $scope.data.selectedCountryCode = $scope.countryCodes[i];
                defaultCodeFound = true;
            }
        }
        if(!defaultCodeFound){
            $scope.data.selectedCountryCode = $scope.countryCodes[0];
        }
        $scope.agents = GetAgents.getAgents() ? GetAgents.getAgents() : "";
        $scope.data.selectedAgent = $scope.agents[0];

        // default selected agent based on login
        var defaultAgentInc2c = AuthService.getUserCredentials()['user_id'];
        // To check if app user(person who is using his credentials to signin)
        // found in agents list
        var userFound = false
        for (var i = 0; $scope.agents.length > i; i++) {
            if($scope.agents[i].id == defaultAgentInc2c){
                $scope.data.selectedAgent = $scope.agents[i];
                userFound = true
                break;
            }
        }
        if($rootScope.allowConsole){
            console.group("Controllers.AppCtrl.Info")
             if(userFound){
                console.info("User found in agents.")
                console.table($scope.data.selectedAgent)
            }else{
                console.error("User not found in agents list.")
                console.info("Default user information")
                console.table($scope.data.selectedAgent)
            }
        }

        //To check if uses is provided with a sr number or not
        if(!angular.isUndefined(AuthService.getUserCredentials()['is_numberless'])
            && !AuthService.getUserCredentials()["is_numberless"]){
            $scope.srNums = AuthService.getUserCredentials()['sr_number'].split(',');
        }else{
            $scope.srNums = new Array()
        }

        //Number of SR number users have
        if($rootScope.allowConsole){
            console.table(AuthService.getUserCredentials())
            console.groupEnd("Controllers.AppCtrl.Info")
        }
        $scope.callerNumbers = ['None'];
        $scope.data.selectedSrNum = $scope.srNums[0];
        $scope.data.selectedCallerIdNum = $scope.callerNumbers[0];
        $ionicModal.fromTemplateUrl('templates/modal/c2c-dialer.html', {
            scope: $scope,
            animation: 'slide-in-up',
            focusFirstInput: true
        }).then(function(modal) {
            $scope.modal = modal;
        });
        $scope.openModal = function(number) {

            self.setNumberInDialer(number);

            $scope.modal.show();
        };

        $scope.pickContact= function () {
            console.log("pick Contact");
            var promise = PhonebookContact.pickContact();

            promise.then(function(contact){
                var selectedContact = contact.phoneNumbers[0].value
                selectedContact = selectedContact.replace(/\s/g,"");
                console.log("callback success for pickContact :"+selectedContact );
                self.setNumberInDialer(selectedContact);
            },function(error){
                console.log("callback failure for pickContact");
            });
        };

        this.setNumberInDialer = function(number) {
            //pre filling number with country code
            if(number != null){
                number = number.replace(/^0+/,defaultCountryCode);
                var regionCode = $window.phoneUtils.getRegionCodeForNumber(number);
                if(regionCode != null){
                    var founded = false;
                    for (var i = $scope.countryCodes.length - 1; i >= 0; i--) {
                        if($scope.countryCodes[i].countryCode == regionCode){
                            $scope.data.selectedCountryCode = $scope.countryCodes[i];
                            founded = true;
                            break;
                        }
                    }
                    if(!founded){
                            //default case in which we are not able to find the number
                            $scope.data.selectedCountryCode = $scope.countryCodes[0];
                    }
                    $scope.data.typedNum = number.slice($scope.data.selectedCountryCode.code.length);
                }else{
                    $scope.data.typedNum = number;
                    defaultCodeFound = false;
                    for (var i = $scope.countryCodes.length - 1; i >= 0; i--) {
                        if($scope.countryCodes[i].code == defaultCountryCode){
                            $scope.data.selectedCountryCode = $scope.countryCodes[i];
                            defaultCodeFound = true;
                        }
                    }
                    if(!defaultCodeFound){
                        //default case in which we are not able to find the number
                        $scope.data.selectedCountryCode = $scope.countryCodes[0];
                    }
                }
            }
          };

        $scope.closeModal = function() {
            $scope.modal.hide();
        };
        // Cleanup the modal when we're done with it!
        $scope.$on('$destroy', function() {
            $scope.modal.remove();
        });
        // Execute action on hide modal
        $scope.$on('modal.hidden', function() {});
        // Execute action on remove modal
        $scope.$on('modal.removed', function() {});

        $scope.c2c = function() {
            GoogleAnalytics.sendEvent("Click2Call", "Call", "Call from c2c-dialler screen");
            //checking if number is vaild or not
            const number = phoneUtil.parseAndKeepRawInput($scope.data.typedNum ,$scope.data.selectedCountryCode.countryCode);
            var isValid =  phoneUtil.isValidNumberForRegion(number,$scope.data.selectedCountryCode.countryCode);
            var dailedNumber = $scope.data.typedNum.replace(/-/g,"");
            dailedNumber = dailedNumber.replace(/\(/g,"");
            dailedNumber = dailedNumber.replace(/\)/g,"");
            dailedNumber = dailedNumber.replace(/\s/g,"");
            if(isValid){
                ClickToCall.c2cClick_country_code($scope.data.selectedSrNum, $scope.data.selectedCountryCode.code, dailedNumber, $scope.data.selectedAgent.country_code, $scope.data.selectedAgent.phone, $scope.data.selectedCallerIdNum);
            }
            else{
                ionicToast.show('Check the number you have dailed', 'middle', false, 1000);
            }
        }

        $scope.fetchCallerIds = function(){
            Loader.show();
            var promise = ClickToCall.getCallerId($scope.data.selectedSrNum);
            promise.then(function(data) {
                $scope.callerNumbers = ['None'];
                $scope.data.selectedCallerIdNum = $scope.callerNumbers[0];
                for(var id in data["callerid"]){
                    console.log("caller id to add == "+data["callerid"][id])
                    $scope.callerNumbers.push(data["callerid"][id]);
                }

            },
            function(reason) {
                ionicToast.show('Failed to fetch cli number', 'middle', false, 1000);

            }).finally(function() {
                Loader.hide();
            });
        }
        // End of C2C dialer controller

        $ionicModal.fromTemplateUrl('templates/modal/media-player.html', {
            scope   : $scope,
        }).then(function(modal) {
            $scope.mediaPlayerModal = modal;
        });
        $scope.openMediaPlayerModal = function(filepath) {
            $scope.mediaPlayerModal.show();
            var player = plyr.get()[0] || plyr.setup()[0];
            player.source({
              type:       'audio',
              sources: [{
                src: filepath,
                type: 'audio/mp3'
              }]
            });
            player.play();
        };

        $scope.playRecording = function(){
            var abc = $ionicPopup.alert({
                templateUrl: 'templates/callRecordPlayer.html',
                cssClass:    'callRecordPlayer',
                buttons: [{
                        text: '<i class="icon ion-ios-close-empty"></i>',
                        type:'popclose',
                        onTap: function(e) {}
                    }]
            });
            // var player = plyr.get()[0] || plyr.setup()[0];
            // player.source({
            //   type:       'audio',
            //   sources: [{
            //     src: 'https://s3.ap-south-1.amazonaws.com/sr-mobile-call-sync/711028/2017/10/13/b29585b9-acdd-447e-bd92-5ad30e7d9aa7.mp3',
            //     type: 'audio/mp3'
            //   }]
            // });
            // player.play();
        };
        $scope.closeMediaPlayerModal = function() {
            $scope.mediaPlayerModal.hide();
            var player = plyr.get()[0] || plyr.setup()[0];
            player.stop();
        };


        $rootScope.internet = 1;
        $rootScope.unknownCaller = {};
        $rootScope.$on('No_Network', function() {
            ionicToast.show('Check Network Connection', 'middle', false, 1000);
        });

        $rootScope.is_owner = AuthService.getUserCredentials().is_owner;
        $rootScope.is_desktop = AuthService.getUserCredentials().device_model === 'Browser';
        $rootScope.is_ios_app = ionic.Platform.isIOS() && window.cordova;
        $rootScope.is_android_app = ionic.Platform.isAndroid() && window.cordova;
        $rootScope.callReceived = false;

        $scope.filterType = 'all';



        $rootScope.fetchCallLogs = function(filterCallType)
        {
            var promise = CallLogService.getCallLog(0, $rootScope.activefilters['filter'], filterCallType,undefined,undefined,$rootScope.mobile);
            promise.then(function(data) {
                    if (data) {
                        $rootScope.addCallData(data.objects);
                        $rootScope.calls = data.objects;
                        $rootScope.callLogCount = data.meta.total_count;
                        $rootScope.callReceived = true;
                    } else {
                        $ionicPopup.alert({
                            title: 'Call Logs',
                            template: 'Error in getting call log, try again later.'
                        });
                    }
                },
                function(reason) {
                    $rootScope.callReceived = true;
                    $ionicPopup.alert({
                        title: 'Call Logs',
                        template: 'Error in fetching Call Logs'
                    });

                }).finally(function() {});
        }
        $rootScope.fetchCallLogs();
        $rootScope.getCallType = function(destination, is_outgoing) {
            return destination.indexOf("Missed") >= 0 ? (is_outgoing ? 'missed_out' : 'missed') : (is_outgoing ? 'outgoing' : 'incoming');
        };
        $rootScope.notesCallData = {};
        $rootScope.addCallData = function(data) {
            for (values in data) {
                var callerph = data[values]['callerph'];
                if ($rootScope.notesCallData[callerph])
                    $rootScope.notesCallData[callerph].push(data[values]);
                else
                    $rootScope.notesCallData[callerph] = new Array(data[values]);
            }
        }
        $rootScope.getName = function(id) {
            if (!$rootScope.contactDataarray[id])
                return 'Unknown';
            else
                return $rootScope.contactDataarray[id][0].phonebook.name;
        }
        $rootScope.getPhonenumber = function(id, callerph) {
            if (!$rootScope.contactDataarray[id])
                return callerph;
            else if (!$rootScope.contactDataarray[id][0].phonebook.phonenumbers_set[0])
                return 'No Number';
            else {
                return $rootScope.contactDataarray[id][0].phonebook.phonenumbers_set[0].number;
            }
        }
        $rootScope.fetchContact = function(status) {
            $rootScope.contactDataarray = {};
            $scope.contactListnotEmpty = true;
            var contactsdatapromise = CustomerData.getCustomerData(0, $rootScope.contactActiveFilters['name'], status);
            //console.log(contactsdatapromise)
            $rootScope.contactReceived = false;
            contactsdatapromise.then(function(data) {
                $rootScope.contactReceived = true;
                $rootScope.customers = data.response['objects'];
                for (values in data.response['objects'])
                    $rootScope.addcontactsData(data.response['objects'][values]);
                $scope.customercount = data.response.meta.total_count;
            }, function(error) {
                $rootScope.contactReceived = true;
                $ionicPopup.alert({
                    title: 'contacts',
                    template: error
                });
            });
        }
        $rootScope.fetchContact();
        $rootScope.addcontactsData = function(data) {
                var mapNumber = data['id'];
                $rootScope.contactDataarray[mapNumber] = new Array(data);
            }
            //click to call global function
        $rootScope.clickTocall = function(obj, category, action, label) {
            GoogleAnalytics.sendEvent(category, action, label);
            if (label.indexOf('schedule calls') != -1 || label.indexOf('completed calls') != -1) {
                if (obj.type.indexOf('missed') == -1)
                    customernumber = obj.contact.phone_numbers;
                else
                    customernumber = obj.phone;
            } else if (label.indexOf('call Logs') != -1)
                customernumber = obj.callerph;
            else if (label.indexOf('contacts screen') != -1)
                customernumber = obj.phonebook.phonenumbers_set[0].number;
            ClickToCall.click(customernumber);
        }
        $scope.filterTypevalue = { 'scheduleFilter': 'All', 'callFilter': 'All', 'contactFilter': 'All', 'scheduleFilterCompleted': 'All' };
        //popups for screens
        $rootScope.startPopup = function(screenname) {
            var filterType = screenname.split('.')[0];
            // google event for filter click
            $scope.choice = { value: $scope.filterTypevalue[filterType] };
            $ionicPopup.confirm({
                templateUrl: screenname,
                scope: $scope,
                buttons: [{
                    text: 'Apply',
                    type: 'button-positive',
                    onTap: function(e) {
                        e.stopPropagation()
                        $ionicScrollDelegate.scrollTop()
                        $scope.filterTypevalue[filterType] = $scope.choice.value
                        if (filterType == 'contactFilter')
                        {
                            $rootScope.fetchContact($scope.filterTypevalue[filterType]);
                        }
                        if (filterType == 'callFilter')
                        {
                            $rootScope.fetchCallLogs($scope.choice.value);
                        }
                    }
                }]
            });
        }
        $rootScope.searchCallLogs = function(query, screen) {
            if (query) {
                return function(call) {
                    if (screen == 'callscreen') {
                        name = $scope.getName(call.receiver_details.cid);
                        if (call.callerph.indexOf(query) != -1)
                            return true;
                        if (name.toLowerCase().indexOf(query.toLowerCase()) != -1)
                            return true;
                    } else if (screen == 'todoscreen') {
                        name = $scope.getName(call.contact_id);
                        if (call.contact.phone_numbers.indexOf(query) != -1)
                            return true;
                        if (name.toLowerCase().indexOf(query.toLowerCase()) != -1)
                            return true;
                    } else if (screen == 'contactscreen') {
                        name = $scope.getName(call.id);
                        if ($scope.getPhonenumber(call.id).indexOf(query) != -1)
                            return true;
                        if (name.toLowerCase().indexOf(query.toLowerCase()) != -1)
                            return true;
                    }
                    return false;
                }
            }
        };
        $rootScope.statusPopup = function(screenname) {
                $scope.statuschoice = { value: $scope.fillfields.status1 };
                $ionicPopup.confirm({
                    templateUrl: screenname,
                    scope: $scope,
                    buttons: [{
                        text: 'Apply',
                        type: 'button-positive',
                        onTap: function(e) {
                            $scope.fillfields.status1 = $scope.statuschoice.value;
                        }
                    }]
                });
            }
            // open new contact screen
        $rootScope.newContactfn = function(page) {
                if (page == 'new') {
                    $scope.value.id = '';
                    $scope.value.contactnumber = '';
                    $scope.screenname = 'Add Contact';
                }
                $scope.fillfields = {};
                if ($scope.value.id == '' && $scope.value.contactnumber == '') {
                    $scope.fillfields.editnumber = $scope.fillfields.id1 = $scope.fillfields.editname = $scope.fillfields.company = '';
                    $scope.fillfields.editphcode = '+91'
                    $scope.fillfields.status1 = 'Cold'
                    $scope.existing = false;
                    $state.go('app.newContact');
                } else {
                    $scope.fillfields.editname = $scope.value.name;
                    $scope.fillfields.editnumber = $scope.value.contactnumber;
                    $scope.fillfields.company = $scope.value.company;
                    $scope.fillfields.status1 = $scope.value.status;
                    $scope.fillfields.id1 = $scope.value.id;
                    $scope.existing = $scope.value.id == '' ? false : true;
                    $scope.screenname = 'Update Contact';
                    $state.go('app.updateContact');
                }
            }
            // refresh call logs
        $rootScope.doRefresh = function() {
                $scope.filterType = 'all';
                $rootScope.noMoreCallLogsAvailable = false;
                var promise = CallLogService.getCallLog(0, $rootScope.activefilters['filter'], $scope.filterTypevalue['callFilter'],undefined,undefined,$rootScope.mobile);
                Loader.show();
                promise.then(function(data) {
                        if (data) {
                            $rootScope.notesCallData = {};
                            $rootScope.addCallData(data.objects);
                            $rootScope.calls = data.objects;
                            $rootScope.callLogCount = data.meta.total_count;
                        } else {
                            $ionicPopup.alert({
                                title: 'Call Logs',
                                template: 'Error in getting call log, try again later.'
                            });
                        }
                    },
                    function(reason) {
                        if(reason != null){
                            $ionicPopup.alert({
                                title: 'Call Logs',
                                template: 'Error in fetching Call Logs'
                            });
                        }
                    }).finally(function() {
                    Loader.hide();
                    $scope.$broadcast('scroll.refreshComplete');
                });
            }
        //profileinfo for customer,calls and todos
        $rootScope.profileinfo = function(obj, screenname) {
                $rootScope.customerdetail_source_screen = screenname;
                userExists = null;
                if (screenname == 'call logs') {
                    id = obj.receiver_details.cid;
                    phone = obj.callerph;
                    name = ''
                    if (obj.receiver_details.name)
                        name = obj.receiver_details.name;
                } else if (screenname == 'schedule call' || screenname == 'completed calls') {
                    id = obj.contact_id;
                    if (obj.type == 'missedcall')
                        phone = obj.phone;
                    else
                        phone = obj.contact.phone_numbers;
                    name = ''
                    if (obj.contact.name)
                        name = obj.contact.name;
                } else if (screenname == 'contacts') {
                    id = obj.id;
                    phone = obj.phonebook.phonenumbers_set[0].number;
                    name = $rootScope.getName(id);
                }
                if (id == '' || !id) {
                    if ($rootScope.unknownCaller[phone]) {
                        userExists = $rootScope.contactDataarray[$rootScope.unknownCaller[phone]];
                        id = $rootScope.unknownCaller[phone];
                        name = userExists[0].phonebook.name;
                        phone = userExists[0].phonebook.phonenumbers_set[0].number;
                    }
                } else {
                    userExists = $rootScope.contactDataarray[id];
                }
                $rootScope.activity = [];
                if (userExists) {
                    $rootScope.globalnotes = userExists[0].notes == '' ? '' : JSON.parse(userExists[0].notes);
                    followupData = userExists[0].followup_dt != "None" ? new Date(userExists[0].followup_dt.replace(/-/g, '/').replace('T', ' ')) : new Date(new Date().getTime() + 5*60000);
                    status = userExists[0]['status'];
                    if (status == 'null')
                        status = 'Cold';
                    company = userExists[0]['phonebook']['company'];
                    if (!userExists[0].phonebook.phonenumbers_set[0])
                        contactnumber = ' ';
                    else
                        contactnumber = userExists[0].phonebook.phonenumbers_set[0].number;
                    id = id;
                } else {
                    if (!id)
                        id = '';
                    $rootScope.globalnotes = company = '';
                    contactnumber = phone;
                    status = 'Cold';
                    followupData = new Date(new Date().getTime() + 5*60000);
                }
                for (var key in $rootScope.globalnotes) {
                    Agentname = $filter('newextractNote')($rootScope.globalnotes[key]);
                    datetime = $filter('newextractTime')($rootScope.globalnotes[key]);
                    if (Agentname)
                        $rootScope.activity.push({ 'Agentname': Agentname, 'datetime': new Date(datetime), 'type': 'notes' });
                }
                for (v in $rootScope.notesCallData[phone]) {
                    dest = $rootScope.notesCallData[phone][v].destination;
                    if (dest[0] == '+') {
                        Agentname = AuthService.getAgentname(dest)
                    } else if (dest.indexOf("Missed") >= 0) {
                        callstatus = dest.split('#')[0];
                        number = dest.split('#')[1];
                        if (number) {
                            Agentname = callstatus + ' : ' + AuthService.getAgentname(number);
                        } else {
                            Agentname = callstatus
                            sr_number = $rootScope.notesCallData[phone][v].sr_number
                        }
                    } else if (dest.indexOf("@") >= 0)
                        Agentname = "Voicemail "
                    else
                        Agentname = dest
                    start_time = $rootScope.notesCallData[phone][v].start_time;
                    filepath = $rootScope.notesCallData[phone][v].filepath
                    duration = $rootScope.notesCallData[phone][v].duration
                    sr_number = $rootScope.notesCallData[phone][v].sr_number
                    start_time = start_time.replace(/-/g, '/').replace('T', ' ')
                    $rootScope.activity.push({ 'Agentname': Agentname, 'datetime': new Date(start_time), 'type': 'callnotes', 'is_outgoing': $rootScope.notesCallData[phone][v].is_outgoing, 'filepath': filepath, 'duration': duration, 'srnumber': sr_number });
                }
                $rootScope.value = { "name": name, "contactnumber": contactnumber, "company": company, "status": status, "id": id, "followupData": followupData };
                location.href = '#/app/customerdetails';
            }
        // Triggered in the login modal to close it
        $scope.closeLogin = function() {
            $scope.modal.hide();
        };

        $scope.doLogout = function() {
            ionicToast.show('Logging Out', 'middle', false, 4000);

            if(window.cordova && ionic.Platform.isAndroid()) {
                    var eventBatch = AuthService.createEventPacket('app_authentication', 'app_logout', 'logout', 'success', false, []);
                    AuthService.captureEvent(eventBatch)
                    .then(function(data){
                        if(data == 'No Network') {
                            Loader.hide();
                            ionicToast.show(data, 'middle', false, 4000);
                        } else {
                            // Stopping Service from Cordova Plugin
                            $cordovaNativeStorage.getItem("record_sync_mobile_calls").then(function (value) {
                                console.log(value);
                                if (value.indexOf('false') == -1) {
                                    var eventPlugin = new EventPlugin();
                                    eventPlugin.logout(
                                        'Call listener stopped!',
                                        function(msg) {
                                            console.log(msg);
                                        },
                                        function(err) {
                                            console.log(err);
                                        }
                                    );
                                }
                            }, function (error) {
                                console.log(error);
                            });

                            // Even after event captured or failed to capture, the following code proceed
                            var credentials = AuthService.getAuthCredentials();
                            if (credentials)
                                AuthService.unSetAuthCredentials();
                            AuthService.unSetUserCredentials();

                            $rootScope.db.transaction(function(tx) {
                                tx.executeSql('UPDATE LoginLogoutTable SET logout = '+Date.now() +' WHERE logout = '+0);
                            }, function(error) {
                                console.log('logout ERROR: ' + error.message);
                                Loader.hide();
                            }, function() {
                                console.log('logout updated OK');
                                location.reload(true);
                                Loader.hide(); //finally removing the loader
                            });
                        };
                    });


            } else {
                    var credentials = AuthService.getAuthCredentials();
                    if (credentials)
                        AuthService.unSetAuthCredentials();
                    AuthService.unSetUserCredentials();

                    location.reload(true);
                    Loader.hide(); //finally removing the loader
            }
        };
        // Open the login modal
        $rootScope.logout = function() {
            Loader.show(); // to show loader so that click will be disabled
            if ($rootScope.is_statusAvailable) {
                var promise = AuthService.changeStatus("Logged Out");
                promise.then(function(data) {
                    GetAgents.unSetAgentStatus();

                    $scope.doLogout();
                },
                function(reason) {
                    var credentials = AuthService.getAuthCredentials();
                    if(credentials){
                        var promise = AuthService.login(credentials);
                        promise.then(function(data){
                            if (reason == null)
                                ionicToast.show('No internet connection', 'middle', false, 1000);
                            else
                                ionicToast.show('Failed to update status! Try after some time.', 'middle', false, 1000);
                            Loader.hide(); //finally removing the loader
                        },
                        function(data){
                            if(data != "No Network"){
                                $scope.doLogout();
                            }
                        })
                    }
                });
            } else {
                $scope.doLogout();
            }
        };
        $scope.movetodesktop = function() {
                var myPopup = $ionicPopup.show({
                    template: 'Our Webapp of super receptionist is optimised for desktop usage and is not the best experience from mobile devices .',
                    title: 'Switch to Desktop Site ?',
                    scope: $scope,
                    buttons: [{
                        text: '<b>Switch</b>',
                        type: 'button-positive',
                        onTap: function(e) {
                            // set cookie
                            document.cookie = "site_desktop=true" + "; domain=.knowlarity.com;path=/";
                            $window.open("https://sr.knowlarity.com/", "_blank");
                        }
                    }, {
                        text: '<b>Stay</b>',
                        type: 'button-positive',
                        onTap: function(e) {}
                    }]
                });
                IonicClosePopupService.register(myPopup);
            }
        //username set
        $scope.useremail  = (AuthService.getUserCredentials()).userid;
        $scope.userphone  = (AuthService.getUserCredentials()).contact_number;
        $scope.first_name = (AuthService.getUserCredentials()).agent_first_name;
        CustomerProfilePic.getProfilePic();
        // Perform the login action when the user submits the login form
        $scope.doLogin = function() {
            // Simulate a login delay. Remove this and replace with your login
            // code if using a login system
            $timeout(function() {
                $scope.closeLogin();
            }, 1000);
        };

        $rootScope.is_statusAvailable=false;
        if (GetAgents.getStatus(AuthService.getUserCredentials()) != null) {
            var promise=GetAgents.getAgentStatus(AuthService.getUserCredentials());
            promise.then(function(data) {
                var status = GetAgents.getStatus(AuthService.getUserCredentials());
                if (status.indexOf("Break") > 0 && AuthService.getBreakList() != null)
                    $rootScope.seletestatus = ("On Break : "+ status);
                else
                    $rootScope.seletestatus = status;
                console.log("Saved status - " + $rootScope.seletestatus)
                if ($rootScope.seletestatus) {
                    $rootScope.is_statusAvailable=true;
                }
            })
        } else {
            var promise=GetAgents.getAgentStatus(AuthService.getUserCredentials());
            promise.then(function(data) {
                if(data) {
                    console.log("data"+data);
                    $rootScope.is_statusAvailable=true;
                    var status = GetAgents.getStatus(AuthService.getUserCredentials());
                    if (status.indexOf("Break") > 0 && AuthService.getBreakList() != null)
                        $rootScope.seletestatus = ("On Break : "+ status);
                    else
                        $rootScope.seletestatus = status;
                    console.log("status added "+ status);
                }
            })

        }

        $scope.agentStatusList = [$rootScope.seletestatus];
        $scope.data.selectedAgentStatus = $scope.agentStatusList[0];

        $scope.fetchStatusList = function(){
                // var promise = AuthService.getStList();
                var data=AuthService.getStList();
                var dataBreak=AuthService.getBreakList();
                //To check if user is agent or not
                $scope.arStatus = data["value"];

                if (dataBreak != null) {
                    $scope.arStatus.splice($scope.arStatus.indexOf("On Break"), 1);
                    dataBreak["data"].forEach(element => {
                        $scope.arStatus.push("On Break : " + element);
                    });
                }

                $scope.agentStatusList = [$rootScope.seletestatus];
                $scope.data.selectedAgentStatus = $scope.agentStatusList[0];
                for(var id in $scope.arStatus){
                    //console.log("status list to add == "+$scope.arStatus[id])
                    $scope.agentStatusList.push($scope.arStatus[id]);
                }
        };

        $scope.changeAgentStatus = function(changedStatus){
            Loader.show();
            var promise = AuthService.changeStatus(changedStatus);
            promise.then(function(data) {
                if (data['status'].indexOf("Break") > 0 && AuthService.getBreakList() != null)
                    $rootScope.seletestatus = ("On Break : "+ data['status']);
                else
                    $rootScope.seletestatus = (data['status']);
                GetAgents.getAgentStatus(AuthService.getUserCredentials());
            },
            function(reason) {
                ionicToast.show('Failed to update status! Try after some time.', 'middle', false, 1000);
            }).finally(function() {
                Loader.hide();
            });
        };
    })
    // customerdetails controller
    .controller('customerdetailsCtrl', function($scope, $log, ClickToCall, SaveContact, $cordovaCalendar, $rootScope, $ionicPopup, $filter, AuthService, ionicToast, IonicClosePopupService, GoogleAnalytics) {
        $scope.$on('$ionicView.enter', function() {
            GoogleAnalytics.screenView('Contact Details');
        });
        var sourceScreen = $rootScope.customerdetail_source_screen;
        var userInfo = AuthService.getUserCredentials();
        $scope.srno = userInfo.sr_number.split(',');
        $scope.defaultsr = '';
        $scope.contact_switch = true;
        $scope.send_note_switch = true;
        $scope.srfooter = true;

        // condition to set the color of status in customer detail screen
        $scope.color = {};
        if ($scope.value.status == 'Cold')
            $scope.color.statusColor = '#EDE9E3';
        else if ($scope.value.status == 'Hot')
            $scope.color.statusColor = '#FFA7B1';
        else if ($scope.value.status == 'Warm')
            $scope.color.statusColor = '#FEDFAD';
        else if ($scope.value.status == 'Closed')
            $scope.color.statusColor = '#C9EDA5';
        $scope.sendNoteToggle = function(bool) {
            $scope.send_note_switch = bool;
            //$scope.srfooter=bool;
        }

        $scope.c2cfromContactDetails = function(srnumber, customernumber, category, action) {
                label = "Call from contact details (via " + sourceScreen + " screen )";
                GoogleAnalytics.sendEvent(category, action, label);
                ClickToCall.c2cClick(srnumber, customernumber);
            }
            //addnote in customerdetail controller
        $scope.addNote = function(notetext) {
            var months = ['Jan', 'Feb', 'Mar', 'Apr', 'May', 'Jun', 'Jul', 'Aug', 'Sep', 'Oct', 'Nov', 'Dec'];
            if (notetext && notetext.length > 0) {
                var date = new Date();
                var promise1;
                notetext = date.getDate() + " " + months[date.getMonth()] + " " + date.getFullYear() + " " + date.getHours() + ':' + date.getMinutes() + " " + notetext;
                var promise = SaveContact.getCallData($scope.value.id);
                promise.then(function(data){
                    responsedata = data.response
                    console.log(responsedata)
                    promise1 = SaveContact.savenewNote(notetext, $scope.value.id, $scope.value.contactnumber,responsedata);
                    promise.then(function(data) {
                        responsedata = data.response;
                        //console.log(responsedata)
                        if (!$rootScope.value.id) {
                            $rootScope.customers.push(responsedata);
                            $rootScope.unknownCaller[$scope.value.contactnumber] = data.response.id;
                        }
                        $scope.send_note_switch = true;
                        $scope.srfooter = true;
                        $rootScope.addcontactsData(responsedata);
                        $rootScope.value = { "name": responsedata['phonebook']['name'], "company": responsedata['phonebook']['company'], "contactnumber": responsedata['phonebook']['phonenumbers_set'][0]['number'], "status": responsedata.status, "id": responsedata.id, "followupData": responsedata.followupData };
                        var Agentname = $filter('newextractNote')(notetext);
                        var datetime = $filter('newextractTime')(notetext);
                        $rootScope.activity.push({ 'Agentname': Agentname, 'datetime': new Date(datetime), 'type': 'notes' });
                    }, function(error) {
                        $ionicPopup.alert({
                            title: 'Notes',
                            template: 'Error in adding notes '
                        });
                    });
                })



            } else
                ionicToast.show('Empty text cannot be added', 'middle', false, 1000);
        }
        $scope.newValue = function(value) {
            $scope.srchoice.value = value;
        }
        $scope.selectSR = function() {
            $scope.srchoice = { value: $scope.defaultsr };
            var myPopup = $ionicPopup.show({
                template: '<div ng-repeat="x in srno track by $index"><ion-radio ng-model="srchoice.value" ng-change="newValue(srno[$index])" ng-value={{x}}>{{x}}</ion-radio></div>',
                title: 'Select SR number',
                scope: $scope,
                buttons: [{
                    text: '<b>Apply</b>',
                    type: 'button-positive',
                    onTap: function(e) {
                        $scope.defaultsr = $scope.srchoice.value
                    }
                }]
            });
            IonicClosePopupService.register(myPopup);
        };
        $scope.schedulePopup = function() {
            $scope.data = { model: new Date($scope.value.followupData) };
            $scope.data.model.setMilliseconds(0)
            var original = $scope.data.model;
            // Custom popup
            var myPopup = $ionicPopup.show({
                template: '<input type = "datetime-local" ng-model = "data.model"  style="line-height:34px">',
                title: 'Enter Followup Date and Time',
                scope: $scope,
                buttons: [{
                    text: '<b>Save</b>',
                    type: 'button-positive',
                    onTap: function(e) {
                        if (!$scope.data.model) {
                            //don't allow the user to close unless he enters model...
                            e.preventDefault();
                        } else if ($scope.data.model > new Date()) {
                            return $scope.data.model;
                        } else {
                            ionicToast.show('Previous date followup cannot be set', 'middle', false, 1000);
                            e.preventDefault();
                        }
                    }
                }]
            });
            IonicClosePopupService.register(myPopup);
            myPopup.then(function(res) {
                var sourceScreen = $rootScope.customerdetail_source_screen;
                GoogleAnalytics.sendEvent("Call Schedule", "Schedule(save button-click)", "Schedule call from " + sourceScreen + " screen");
                if (res > new Date()) {
                    if (!$scope.value.id)
                        $scope.existing = false
                    else
                        $scope.existing = true;
                    SaveContact.savenewContact($scope.value.name, $scope.value.contactnumber, '', $scope.value.status, $scope.value.id, res, $scope.existing, 'followup');
                }
            });
        };
    })
    // Calls Controller
    .controller('callsCtrl', function($scope, $rootScope, CustomerData, CallLogService, $ionicPopup, Loader, ionicToast, $cordovaMedia, GoogleAnalytics, $ionicHistory) {
        $scope.aToCToggle = true;
        $scope.choice = 'S';
        $ionicHistory.clearHistory();
        $scope.$on('$ionicView.enter', function() {
            // Any thing you can think of
            GoogleAnalytics.screenView('Calls');
        });
        $scope.$watch('calls', function() {
            if ($rootScope.calls && $rootScope.calls.length == $rootScope.callLogCount) {
                $rootScope.noMoreCallLogsAvailable = true;
            }
        });
        if ($rootScope.internet == 1) {
            $scope.$watch('callReceived', function() {
                $scope.callReceived == false ? Loader.show() : Loader.hide();
            });
        }
        $scope.title = "Calls";
        $rootScope.noMoreCallLogsAvailable = false;
        // audio object for app.knowlarity call play
        $scope.audio = document.createElement('audio');
        $scope.loadMore = function(mobile) {
            $scope.filterType = 'all';
            var promise = CallLogService.getCallLog($rootScope.calls.length==0? 0 : $rootScope.calls.length+1, $rootScope.activefilters['filter'], $scope.filterTypevalue['callFilter'],undefined,undefined,$rootScope.mobile);
            promise.then(function(data) {
                    if(data){
                        $rootScope.addCallData(data.objects);
                        $rootScope.calls = $rootScope.calls.concat(data.objects);
                    } else {
                        $ionicPopup.alert({
                            title: 'Call Logs',
                            template: 'Error in getting call log, try again later.'
                        });
                    }
                },
                function(reason) {
                    Loader.hide();
                    $ionicPopup.alert({
                        title: 'Call Logs',
                        template: 'Please check your network and try again later.'
                    });
                }).finally(function() {
                $scope.$broadcast('scroll.infiniteScrollComplete');
            });
        };
        $scope.filterCallLogs = function(row) {
            if ($scope.filterTypevalue['callFilter'] == 'missed') {
                $scope.title = "Missed Calls";
                return row.ftype.indexOf("Missed Call") >= 0;
            } else if ($scope.filterTypevalue['callFilter'] == 'outgoing') {
                $scope.title = "Outgoing Calls";
                return row.is_outgoing;
            } else if ($scope.filterTypevalue['callFilter'] == 'incoming') {
                $scope.title = "Incoming Calls";
                return !row.is_outgoing;
            } else if ($scope.filterTypevalue['callFilter'] == 'voicemail') {
                $scope.title = "Voicemail";
                return row.ftype == "Voicemail";
            } else if ($scope.filterTypevalue['callFilter'] == 'blacklist') {
                $scope.title = "Blacklist";
                return row.destination == "BlackList";
            }
            $scope.title = "Calls";
            return true;
        };
        /* this function trigger via call log page toggle
        * and changes the android call log to Click to call logs
        * by default C2C calls are shown
        */
        $scope.toggleAndroidToC2C = function(){
            toggleValue  = $scope.choice == 'S'?true:false;

            if (toggleValue) {
                $rootScope.mobile = false;
                $rootScope.doRefresh();

            } else {
                $rootScope.mobile = true;
                $rootScope.doRefresh();
            }
        }
        $scope.searchInput = function(){
            searchBoxValue = $scope.search2;
            delete $rootScope.activefilters['filters'];
            $rootScope.noMoreCallLogsAvailable = false;
            is_alphabet = searchBoxValue.match(/[a-z]/i);
            if (is_alphabet)
            {
                Loader.show();
                var promise = CustomerData.getCustomerData(0, searchBoxValue);
                promise.then(
                    function(data)
                    {
                        var contacts = data.response['objects'];
                        var filterNumbers = [];
                        for (var i=0; i<contacts.length; i++) {
                            contactName = contacts[i].phonebook['name'];
                            if (contactName.toLowerCase().startsWith(searchBoxValue.toLowerCase())) {
                                filterNumbers.push(contacts[i].phonebook.phonenumbers_set[0]['number']);
                            }
                        }
                        if (filterNumbers.length > 0) {
                            var promise = CallLogService.getCallLog(0, filterNumbers.join(","), $scope.filterTypevalue['callFilter'],undefined,undefined,$rootScope.mobile);
                            $rootScope.activefilters['filter'] = filterNumbers.join(",");
                            promise.then(function(data) {
                                    if (data)  {
                                        $rootScope.notesCallData = {};
                                        $rootScope.addCallData(data.objects);
                                        $rootScope.calls = data.objects;
                                        $rootScope.callLogCount = data.meta.total_count;
                                    } else {
                                        $ionicPopup.alert({
                                            title: 'Call Logs',
                                            template: 'Error in getting call log, try again later.'
                                        });
                                    }
                                },function(reason) {
                                    Loader.hide();
                                    if (reason != null)
                                    {
                                        $ionicPopup.alert({
                                            title: 'Call Logs',
                                            template: 'Please check your network and try again later.'
                                        });
                                    }
                                });
                        }
                        else {
                            Loader.hide();
                            $rootScope.activefilters['filter'] = searchBoxValue;
                            $rootScope.notesCallData = {};
                            $rootScope.addCallData([]);
                            $rootScope.calls = [];
                            $rootScope.callLogCount = 0;
                        }
                    },
                    function(reason) {
                        Loader.hide();
                        if (reason != null)
                        {
                            $ionicPopup.alert({
                                title: 'Call Logs',
                                template: 'Please check your network and try again later.'
                            });
                        }
                    });
            }
            else {
                var promise = CallLogService.getCallLog(0, searchBoxValue, $scope.filterTypevalue['callFilter'],undefined,undefined,$rootScope.mobile);
                $rootScope.activefilters['filter'] = searchBoxValue;
                promise.then(function(data) {
                        if (data) {
                            $rootScope.notesCallData = {};
                            $rootScope.addCallData(data.objects);
                            $rootScope.calls = data.objects;
                            $rootScope.callLogCount = data.meta.total_count;
                        } else {
                            $ionicPopup.alert({
                                title: 'Call Logs',
                                template: 'Error in getting call log, try again later.'
                            });
                        }
                    },function(reason) {
                        Loader.hide();
                        if (reason != null)
                        {
                            $ionicPopup.alert({
                                title: 'Call Logs',
                                template: 'Please check your network and try again later.'
                            });
                        }
                    });
            }
        }
        $scope.playRecording2 = function()
        {
            $ionicPopup.show(
            {
                templateUrl: 'templates/callRecordPlayer.html',
                cssClass:    'callRecordPlayer',
                buttons: [{
                        text: '<i class="icon ion-ios-close-empty"></i>',
                        type:'popclose',
                        onTap: function(e) {}
                    }]
            });
            var player = plyr.get()[0] || plyr.setup()[0];
            player.source({
              type:       'audio',
              sources: [{
                src: filepath,
                type: 'audio/mp3'
              }]
            });
            player.play();
        }
        $rootScope.play = function(myEv, src) {
            GoogleAnalytics.sendEvent("Call Recording", "Play", "call Record Play");
            if ($rootScope.is_desktop) {
                if ($rootScope.filebeingplayed) {
                    ionicToast.show('Please Pause', 'middle', false, 1000);
                    return;
                }else{
                    $scope.audio.src = src;
                    $scope.audio.play();
                }

            }else {
                if ($rootScope.filebeingplayed) {
                    ionicToast.show('Please Pause', 'middle', false, 1000);
                    return;
                }
                if ($rootScope.currently_playingfileevent) {
                    $rootScope.pause($rootScope.currently_playingfileevent, 'playPause');
                    $rootScope.localplayingfileevent = $rootScope.currently_playingfileevent;
                } else
                    $rootScope.localplayingfileevent = myEv;
                $rootScope.currently_playingfileevent = myEv;
                if ($rootScope.mediaSuccessCallback_done)
                    $rootScope.mediaSuccessCallback();
                $rootScope.media = new Media(src, $rootScope.mediaSuccessCallback,
                    // success callback
                    function() {
                        console.log("recordAudio():Audio Success");
                    },
                    // error callback
                    function(err) {
                        console.log("recordAudio():Audio Error: "+ err.code);
                    });
                $rootScope.media.play();
                $rootScope.mediaSuccessCallback_done = false;
                ionicToast.show('Playing Record', 'middle', false, 1000);
            }
            element_id = myEv.currentTarget.id;
            document.getElementById(element_id).className += " play_pause";
            document.getElementById('pause_' + element_id.slice(5)).className = "ion-pause";
            $rootScope.current_element_id = element_id.slice(5);
            $rootScope.filebeingplayed = 1;
        }
        $rootScope.pause = function(myEv, internal) {
            $rootScope.filebeingplayed = 0;
            if ($rootScope.is_desktop) {
                $scope.audio.pause();
                element_id = myEv.currentTarget.id;
                document.getElementById(element_id).className += " play_pause";
                document.getElementById('play_' + element_id.slice(6)).className = "ion-play megalarge";
            } else {
                if (internal) {
                    element_id = myEv.target.id;
                    document.getElementById('pause_' + element_id.slice(5)).className += " play_pause";
                    document.getElementById(element_id).className = "ion-play megalarge";
                } else {
                    element_id = myEv.currentTarget.id;
                    document.getElementById(element_id).className += " play_pause";
                    document.getElementById('play_' + element_id.slice(6)).className = "ion-play megalarge";
                }
                if (internal != 'mediaSuccessCallback')
                    $rootScope.media.release();
            }
        }
        $rootScope.mediaSuccessCallback = function() {
            $rootScope.mediaSuccessCallback_done = true;
            $rootScope.pause($rootScope.localplayingfileevent, 'mediaSuccessCallback');
            $rootScope.localplayingfileevent = $rootScope.currently_playingfileevent;
        }

        $scope.audio.addEventListener('ended', function() {
            $scope.$apply(function() {
                $scope.audio.pause();
                element_id = $rootScope.current_element_id;
                document.getElementById('pause_' + element_id).className += " play_pause";
                document.getElementById('play_' + element_id).className = "ion-play megalarge";
                $rootScope.filebeingplayed = 0;
            });
        });

        $scope.mobile_logs = false;
        $scope.toggle_mobile_logs = function(){
            if($scope.mobile_logs){
                $scope.mobile_logs = false;
                $rootScope.calls = []
                $scope.loadMore(false);
            }
            else
            {
                $scope.mobile_logs = true;
                $rootScope.calls = []
                $scope.loadMore(true);
            }
        }
    })
    // Contacts Controller
    .controller('contactsCtrl', function($scope, CustomerData, Loader, $ionicPopup, GoogleAnalytics, $rootScope, $ionicHistory) {
        $rootScope.contactActiveFilters = {};
        $scope.$on('$ionicView.enter', function() {
            GoogleAnalytics.screenView('Contacts');
        });
        $ionicHistory.clearHistory();
        $scope.$watch('customers', function() {
            if ($scope.customers.length >= $scope.customercount) {
                $scope.noMoreContactAvailable = true;
            }
        });
        $scope.onSearch = function()
        {
            Loader.show();
            var searchBoxValue = $scope.search;
            // set active filters to be later used during refress and loadmore
            $rootScope.contactActiveFilters['name'] = searchBoxValue;
            // get contacts whose contact name starts with searchBoxValue
            var promise = CustomerData.getCustomerData(0, searchBoxValue, $scope.filterTypevalue['contactFilter']);
            promise.then(function(data)
            {
                // add the returned data to the contacts list variable for the UI
                var customerData = data.response['objects'];
                $scope.customercount = data.response.meta.total_count;
                $rootScope.customers = customerData;
                for (values in customerData)
                {
                    $rootScope.addcontactsData(customerData[values]);
                }
                Loader.hide();
            }, function(error)
            {
                Loader.hide();
                 $ionicPopup.alert(
                 {
                    title    : 'Contacts',
                    template : 'There was an error in fetching contacts. Please try again later.'
                 });

            });
        };
        $scope.noMoreContactAvailable = false;
        $scope.loadMoreContacts = function() {
            $scope.filterType = 'All';
            var promise = CustomerData.getCustomerData($scope.customers.length, $rootScope.contactActiveFilters['name'], $scope.filterTypevalue['contactFilter']);
            promise.then(function(data) {
                $rootScope.customers = $scope.customers.concat(data.response['objects']);
                for (values in data.response['objects'])
                    $rootScope.addcontactsData(data.response['objects'][values]);
            }, function(error) {
                $ionicPopup.alert({
                    title: 'contacts',
                    template: 'contacts not loaded'
                });
            }).finally(function() {
                $scope.$broadcast('scroll.infiniteScrollComplete');
            });
        };
        if ($rootScope.internet == 1) {
            $scope.$watch('contactReceived', function() {
                $scope.contactReceived == false ? Loader.show() : Loader.hide();
            });
        }
        $rootScope.value = {} /* global value for details in customerdetail and new contact screen */
        $scope.refreshContact = function() {
            var promise = CustomerData.getCustomerData(0, $rootScope.contactActiveFilters['name'], $scope.filterTypevalue['contactFilter']);
            Loader.show();
            promise.then(function(data) {
                $scope.customercount = data.response.meta.total_count;
                $rootScope.customers = data.response['objects'];
                for (values in data.response['objects'])
                    $rootScope.addcontactsData(data.response['objects'][values]);
            }, function(error) {
                if(error != null){
                    $ionicPopup.alert({
                        title: 'contacts',
                        template: 'contacts not loaded'
                    });
                }
            }).finally(function() {
                Loader.hide();
                $scope.$broadcast('scroll.refreshComplete');
            });
        };
        $scope.filterContacts = function(value) {
            if ($scope.filterTypevalue['contactFilter'] == 'Hot')
                return value.status == 'Hot'
            else if ($scope.filterTypevalue['contactFilter'] == 'Cold')
                return value.status == 'Cold'
            else if ($scope.filterTypevalue['contactFilter'] == 'Warm')
                return value.status == 'Warm'
            else if ($scope.filterTypevalue['contactFilter'] == 'Closed')
                return value.status == 'Closed'
            else return true;
        }
    })

    // signup controller
    .controller('signUpCtrl', function($scope, $http, $rootScope, Loader, $window, $ionicPopup, ionicToast, GoogleAnalytics, $state, countryCodevalues, getTelcoCircle, IonicClosePopupService) {
        $scope.$on('$ionicView.enter', function() {
            GoogleAnalytics.screenView('SignUp');
        });
        $rootScope.$on('No_Network', function() {
            ionicToast.show('Check Network Connection', 'middle', false, 1000);
        });
        $scope.is_createAcc = false;
        $scope.closeSignUpModal = function() {
            $state.go("login");
        }
        $scope.init = function() {
            $scope.data = {};
            $scope.data.name = '';
            $scope.data.email = '';
            $scope.data.number = '';
            $scope.emailStatus  = true;
            $scope.nameStatus   = true;
            $scope.numberStatus = true;
            $scope.countryCodes = countryCodevalues;
            $window.localStorage.setItem("signupName", "");
            $window.localStorage.setItem("signupNumber", "");
            $window.localStorage.setItem("signupEmail", "");
            $window.localStorage.setItem("signupContryCode", "");
            $window.localStorage.setItem("signupContryName", "");
        };
        $scope.init();
        $scope.emailChange = function(email){
            var re = /^(([^<>()\[\]\\.,;:\s@"]+(\.[^<>()\[\]\\.,;:\s@"]+)*)|(".+"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/;
            var result = re.test(email);
            if(result)
                $scope.emailStatus = false;
            else
                $scope.emailStatus = true;
        };

        $scope.nameChange = function(name){
            if (name)
                $scope.nameStatus = false;
            else
                $scope.nameStatus = true;
        };

        $scope.numberChange = function(number){
            if (number)
                $scope.numberStatus = false;
            else
                $scope.numberStatus = true;
        };

        $scope.submitRequest = function(name, email, number_prefix, number, source) {

            if (typeof(name) == 'undefined'
                || typeof(email) == 'undefined'
                || typeof(number_prefix) == 'undefined'
                || typeof(number) == 'undefined' ) {
                $scope.showError("Please check the data you have entered!");
            } else {
                const raw_number = phoneUtil.parseAndKeepRawInput(number ,number_prefix['countryCode']);
                var isValid = phoneUtil.isValidNumberForRegion(raw_number, number_prefix['countryCode']);
                if (!isValid) {
                    $scope.showError('Check the number you have entered!');
                    return;
                }
                if (!$rootScope.online) {
                    $scope.showError('Check Internet connection!');
                    return;
                }
                $window.localStorage.setItem("signupName", name);
                $window.localStorage.setItem("signupNumber", number);
                $window.localStorage.setItem("signupEmail", email);
                $window.localStorage.setItem("signupContryCode", number_prefix.code);
                $window.localStorage.setItem("signupContryName", number_prefix.name);
                $scope.checkSRacc(name, number_prefix.code + number, email, source);
            }
        }

        $scope.checkSRacc = function(name, phone, email, source) {
            Loader.show();
            var parameters = {
                'phone' : phone,
                'email' : email
            };
            $http({
                method: 'GET',
                url: 'https://www.knowlarity.com/api/checkSRacc.php',
                params: parameters
            })
            .success(function(data, code) {
                Loader.hide();
                if (code == 400 || code == 500) {
                    $scope.showError("Something went wrong! Please try again.");
                } else if (code == 200) {
                    if (!data.is_user_exists_email && !data.is_user_exists_number) {
                        if (source == "trialAcc") {
                            //get the caller circle from the leads phone number
                            $scope.caller_circle_promise = getTelcoCircle.get_telco_circle(phone);
                            $scope.caller_circle_promise.then(function(data)
                            {
                                $scope.caller_circle = data;
                                $scope.createLead(name, phone, $scope.caller_circle, email);
                            });
                        } else if (source == "createAcc") {
                            $scope.generateOTP(phone);
                        }
                    } else {
                        $scope.showError("User already exits!");
                    }
                }
            })
            .error(function(msg, code) {
                Loader.hide();
                if (code == 400 || code == 500)
                    $scope.showError("Something went wrong! Please try again.");
                else
                    $scope.showError("Request error! Please try again.");
            });
        };

        $scope.createLead = function(name, phone, circle, email) {
            Loader.show();
            var parameters = {
                'name' : name,
                'phone' : phone,
                'operation' : 'search_and_update',
                'circle' : circle,
                'email' : email,
                'mode' : 'Mobile',
                'reffered_by' : 'Mobile SignUp page',
                'product' : 'SR Mobile'
            };
            $http({
                method: 'GET',
                url: 'https://www.knowlarity.com/api/tollfree_sendzoho.php',
                params: parameters
            })
            .success(function(data) {
                Loader.hide();
                // Check if the response contains error
                parser = new DOMParser();
                xmlDoc = parser.parseFromString(data,"text/xml");
                if (xmlDoc.getElementsByTagName('error').length > 0) {
                     $scope.showError("Request error! Please try again.");
                } else {
                    $scope.init();
                    // Go to success page
                    $state.go('trial_acc_success');
                }
            })
            .error(function(msg, code) {
                Loader.hide();
                $scope.showError("Request error! Please try again.");
            });
        };

        $scope.generateOTP = function(phone) {
            Loader.show();
            var parameters = {
                'phone_number' : phone
            };
            $http({
                method: 'GET',
                url: 'https://www.knowlarity.com/api/generateOTP.php',
                params: parameters
            })
            .success(function(data, code) {
                Loader.hide();
                if (code == 400 || code == 500) {
                    $scope.showError("Something went wrong! Please try again.");
                } else if (code == 200) {
                    $state.go('validateOTP');
                }
            })
            .error(function(msg, code) {
                Loader.hide();
                if (code == 400 || code == 500)
                    $scope.showError("Something went wrong! Please try again.");
                else
                    $scope.showError("Request error! Please try again.");
            });
        };

        $scope.showError = function(message) {
            var myPopup = $ionicPopup.show({
                template: message,
                title: 'Sign up',
                scope: $scope,
                buttons: [{
                    text: '<b>OK</b>',
                    type: 'button-positive',
                    onTap: function(e) {}
                }]
            });
            IonicClosePopupService.register(myPopup);
        };

        $scope.activateNow = function() {
            $scope.is_createAcc = false;
        };

        $scope.createNow = function() {
            $scope.is_createAcc = true;
        };
    })

    // Validate OTP controller
    .controller('validateOTPCtrl', function($scope, $state, CreateSRAccount, $window, $http, Loader, GoogleAnalytics, ionicToast, $rootScope, $ionicPopup, IonicClosePopupService) {
        $scope.$on('$ionicView.enter', function() {
            GoogleAnalytics.screenView('validateOTP');
        });
        $rootScope.$on('No_Network', function() {
            ionicToast.show('Check Network Connection', 'middle', false, 1000);
        });
        $scope.closeSignUp2Modal = function() {
            $state.go("signUp");
        }
        $scope.firstOTP = "";
        $scope.secondOTP = "";
        $scope.thirdOTP = "";
        $scope.forthOTP = "";
        $scope.signupName =  $window.localStorage.getItem("signupName");
        $scope.signupNumber =  $window.localStorage.getItem("signupNumber");
        $scope.signupEmail =  $window.localStorage.getItem("signupEmail");
        $scope.signupContryCode =  $window.localStorage.getItem("signupContryCode");
        $scope.signupContryName =  $window.localStorage.getItem("signupContryName");

        $scope.is_resent_enabled = false;
        var count = 60
        $scope.countDown = count;
        $scope.timer = function() {
            if($scope.countDown){
                $scope.countDown--;
                if(!$scope.countDown){
                    $scope.is_resent_enabled = true;
                    return;
                }
            }
            $scope.$apply();
            clearInterval($scope.$apply());
        };

        $scope.timer_interval = setInterval($scope.timer,1000);

        $scope.startCounter = function(){
            $scope.timer_interval();
        }

        $scope.timer_count=setTimeout(function (){
            $scope.is_resent_enabled = true;
        },60000);

        $scope.resendOTP = function() {
            $scope.firstOTP = "";
            $scope.secondOTP = "";
            $scope.thirdOTP = "";
            $scope.forthOTP = "";
            $scope.countDown = 60;
            $scope.is_resent_enabled = false;
            $scope.startCounter();
        }

        $scope.allElements = document.querySelectorAll('.sign_up_otp_input');
        var i;
        for (i = 0; i < $scope.allElements.length-1; i++) {
            var el = $scope.allElements[i];
            el.addEventListener("keyup", (function(n) {
                return function() {
                    this.nextSibling.nextSibling.focus();
                }
            })(i));
        }
        var last = $scope.allElements[$scope.allElements.length-1];
        last.addEventListener("keyup", function(n) {
            $scope.varifyOTP($scope.signupNumber, $scope.firstOTP + $scope.secondOTP + $scope.thirdOTP + $scope.forthOTP);
        });

        $scope.generateOTP = function(phone) {
            Loader.show();
            var parameters = {
                'phone_number' : phone
            };
            $http({
                method: 'GET',
                url: 'https://www.knowlarity.com/api/generateOTP.php',
                params: parameters
            })
            .success(function(data, code) {
                Loader.hide();
                if (code == 400 || code == 500) {
                    $scope.showError("Something went wrong! Please try again.","signUp");
                } else if (code == 200) {
                    $scope.resendOTP();
                }
            })
            .error(function(msg, code) {
                Loader.hide();
                if (code == 400 || code == 500)
                    $scope.showError("Something went wrong! Please try again.","signUp");
                else
                    $scope.showError("Request error! Please try again.","");
            });
        };

        $scope.varifyOTP = function(phone, otp) {
            if (otp.length === 4) {
                Loader.show();
                var parameters = {
                    'phone_number' : phone,
                    'otp' : otp
                };
                $http({
                    method: 'GET',
                    url: 'https://www.knowlarity.com/api/verifyPhone.php',
                    params: parameters
                })
                .success(function(data, code) {
                    Loader.hide();
                    if (code == 400 || code == 500) {
                        $scope.showError("Something went wrong! Please try again.","signUp");
                    } else if (code == 200) {
                        if (data.toLowerCase().indexOf("otp has been verified") > -1) {
                            // $state.go("setPassword");
                            $scope.createSRAccount();
                        } else {
                            $scope.showError(data,"");
                        }
                    }
                })
                .error(function(msg, code) {
                    Loader.hide();
                    if (code == 400 || code == 500)
                        $scope.showError("Something went wrong! Please try again.","signUp");
                    else
                        $scope.showError("Request error! Please try again.","");
                });
            }
        };

        $scope.createSRAccount = function() {
            var promise = CreateSRAccount.createSRAcc($scope.signupEmail,
                                    $scope.signupContryCode + $scope.signupNumber,
                                    $scope.signupName);
            promise.then(function(data) {
                console.log(JSON.stringify(data));
                if (data.response.success) {
                    // $state.go("set_password_success");
                    if (data.response.success.status.toString().toLowerCase().indexOf("success") > -1)
                        $scope.showError("Your account has been created successful. You will get SMS shortly.", "login");
                } else if (data.response.error) {
                    if (data.response.error.message.toString().toLowerCase().indexOf("already exists") > -1)
                        $scope.showError(data.response.error.message, "login");
                    else
                        $scope.showError(data.response.error.message, "signUp");
                }
            } ,
            function(reason) {
                console.log(JSON.stringify(reason));
                if (reason.error.message)
                    $scope.showError(reason.error.message, "signUp");
            });
        };

        $scope.showError = function(message, redirectTo) {
            var myPopup = $ionicPopup.show({
                template: message,
                title: 'Validate OTP',
                scope: $scope,
                buttons: [{
                    text: '<b>OK</b>',
                    type: 'button-positive',
                    onTap: function(e) {
                        if (redirectTo.length > 0) {
                            $state.go(redirectTo);
                        }
                    }
                }]
            });
            IonicClosePopupService.register(myPopup);
        };

    })

    // Set Password Controller
    .controller('setPasswordCtrl', function($scope, $state, Loader, CreateSRAccount, $window, GoogleAnalytics, $http, ionicToast, $rootScope, $ionicPopup, IonicClosePopupService) {
        $scope.$on('$ionicView.enter', function() {
            GoogleAnalytics.screenView('Set Password');
        });
        $rootScope.$on('No_Network', function() {
            ionicToast.show('Check Network Connection', 'middle', false, 1000);
        });
        $scope.signupName =  $window.localStorage.getItem("signupName");
        $scope.signupNumber =  $window.localStorage.getItem("signupNumber");
        $scope.signupEmail =  $window.localStorage.getItem("signupEmail");
        $scope.signupContryCode =  $window.localStorage.getItem("signupContryCode");
        $scope.signupContryName =  $window.localStorage.getItem("signupContryName");

        $scope.init = function() {
            $scope.data = {};
            $scope.data.password = '';
            $scope.data.repassword = '';
            $scope.passwordStatus = true;
            $scope.repasswordStatus = true;
        };
        $scope.init();

        $scope.passwordChange = function(password){
            if (password)
                $scope.passwordStatus = false;
            else
                $scope.passwordStatus = true;
        };

        $scope.repasswordChange = function(repassword){
            if (repassword)
                $scope.repasswordStatus = false;
            else
                $scope.repasswordStatus = true;
        };

        $scope.createSRAccount = function(password, repassword) {
            if (password == repassword) {
                // var promise = CreateSRAccount.registerUser($scope.signupContryCode + $scope.signupNumber,
                //                 $scope.signupEmail,
                //                 $scope.signupName,
                //                 '',
                //                 password,
                //                 $scope.signupContryCode,
                //                 $scope.signupContryName);
                // promise.then(function(data) {
                //     console.log(data);
                //     if (data.success)
                //         $state.go("set_password_success");
                // } ,
                // function(reason) {
                //     console.log(reason.error.message);
                //     if (reason.error.message)
                //         $scope.showError(reason.error.message);
                // });


            } else {
                $scope.showError("Password not matching!");
            }
        };

        $scope.showError = function(message) {
            var myPopup = $ionicPopup.show({
                template: message,
                title: 'Set Password Error!',
                scope: $scope,
                buttons: [{
                    text: '<b>OK</b>',
                    type: 'button-positive',
                    onTap: function(e) {

                    }
                }]
            });
            IonicClosePopupService.register(myPopup);
        };
    })

    // Terms and Conditions controller
    .controller('termsAndConditionsCtrl', function($scope, GoogleAnalytics, $rootScope, ionicToast, $window, TnCService, $location, AuthService) {
        $scope.$on('$ionicView.enter', function() {
            GoogleAnalytics.screenView('Terms and Conditions');
        });
        $rootScope.$on('No_Network', function() {
            ionicToast.show('Check Network Connection', 'middle', false, 1000);
        });

        $scope.openTermsLink = function() {
            $window.open('https://www.knowlarity.com/terms-of-use/', '_blank');
        }

        $scope.openPrivacyLink = function() {
            $window.open('https://www.knowlarity.com/privacy-policy/', '_blank');
        }

        $scope.acceptTnC = function() {
            var promise = TnCService.changeTnCStatus();
            promise.then(function(data) {
                // ionicToast.show(data, 'middle', false, 1000);
            },
            function(reason) {
                ionicToast.show('Failed to update TnC status ' + reason, 'middle', false, 1000);
            }).finally(function() {
                    $rootScope.performDeeplink(AuthService.getUserCredentials());
            });
        }

        $scope.declineTnC = function() {
            $rootScope.logout();
        }
    })

    // Todos Controller
    .controller('todosCtrl', function($scope, CustomerData, TodoService, GoogleAnalytics, $ionicPopup, $rootScope, $ionicHistory, $q, Loader) {
        $scope.$on('$ionicView.enter', function() {
            GoogleAnalytics.screenView('Scheduled Calls');
            $scope.resetActiveFilters();
        });
        $ionicHistory.clearHistory();
        $scope.activefilters = {};
        $scope.noMoreScheduledTodosAvailable = false;
        $scope.noMoreCompletedTodosAvailable = false;
        $scope.tododata_scheduled = [];
        $scope.tododata_completed = [];
        $scope.showSchedule = true;
        $scope.filteredSchedule = { 'value': '' };
        $scope.filteredcompleted = { 'value': '' };
        $scope.resetActiveFilters = function() {
            //reset active filters
            $scope.activefilters = {}
            $scope.noMoreScheduledTodosAvailable = false;
            $scope.noMoreCompletedTodosAvailable = false;
            $scope.search = '';

            if ($scope.showSchedule == true){
                var promise = TodoService.getTodoData({offset:0, is_completed: false});
                promise.then(function(data){
                        $scope.totalScheduled = data.meta.total_count;
                        $scope.tododata_scheduled = data.response;},
                    function(reason){
                        if(reason != null){
                                    $ionicPopup.alert({
                                        title: 'Todo',
                                        template: 'Error Loading ! Pull to refresh...' });}
                    });
            }
            else if ($scope.showSchedule == false) {
                var promise = TodoService.getTodoData({offset:0, is_completed: true});
                promise.then(function(data) {
                        $scope.totalCompleted = data.meta.total_count;
                        $scope.tododata_completed = data.response;},
                    function(reason){
                        if(reason != null) {
                                    $ionicPopup.alert({
                                        title: 'Todo',
                                        template: 'Error Loading ! Pull to refresh.'});}
                    });
            }
        }
        $scope.$watch('showSchedule', function()
        {
            $scope.resetActiveFilters();
        });

        $scope.$watchCollection('tododata_scheduled', function() {
            if ($scope.tododata_scheduled.length >= $scope.totalScheduled) {
                $scope.noMoreScheduledTodosAvailable = true; }
        });
        $scope.$watchCollection('tododata_completed', function() {
            if ($scope.tododata_completed.length >= $scope.totalCompleted) {
                $scope.noMoreCompletedTodosAvailable = true; }
        });
        var promise = $q.all([TodoService.getTodoData({offset:0, is_completed: false}), TodoService.getTodoData({offset:0, is_completed: true})])
        promise.then(function(data) {
            $scope.totalScheduled = data[0].meta.total_count;
            $scope.tododata_scheduled = data[0].response;

            $scope.totalCompleted = data[1].meta.total_count;
            $scope.tododata_completed = data[1].response;

        }, function(reason) {
            if(reason != null){
                        $ionicPopup.alert({
                            title: 'Todo',
                            template: 'Error Loading. Pull to refresh.'});}
        });

        $scope.searchInput = function(is_completed){
            var searchBoxValue = $scope.search;
            var is_alphabet = /[a-z]/i.test(searchBoxValue);
            // Remove active filters
            $scope.activefilters = {}
            $scope.noMoreScheduledTodosAvailable = false;
            $scope.noMoreCompletedTodosAvailable = false;

            if (is_alphabet) {
                Loader.show();
                var promise = CustomerData.getCustomerData(0, searchBoxValue);
                promise.then(function(data) {
                    var contacts = data.response['objects'];
                    var filterNumbers = [];
                    for (var i=0; i<contacts.length; i++) {
                        contactName = contacts[i].phonebook['name'];
                        if (contactName.toLowerCase().startsWith(searchBoxValue.toLowerCase())) {
                            filterNumbers.push(contacts[i].phonebook.phonenumbers_set[0]['number']);
                        }
                    }
                    if (filterNumbers.length > 0) {
                        var options = {}
                        options['is_completed'] = is_completed;
                        options['offset'] = 0;
                        options['phone__in'] =  filterNumbers.join(",");
                        $scope.activefilters['phone__in']  = filterNumbers.join(",");

                        var promise = TodoService.getTodoData(options);

                        promise.then(function(data)  {
                            if (is_completed == false) {
                                $scope.totalScheduled = data.meta.total_count;
                                $scope.tododata_scheduled = data.response;}
                            else if (is_completed == true) {
                                $scope.totalCompleted = data.meta.total_count;
                                $scope.tododata_completed = data.response;
                            }
                        },
                        function(reason) {
                            Loader.hide();
                            if(reason != null)
                            {
                                $ionicPopup.alert({
                                    title:    'Scheduled Calls',
                                    template: 'Unable to fetch Scheduled Calls. Please check your network and try again later.'});
                            }
                        });
                    }
                    else
                    {
                        Loader.hide();
                        $scope.activefilters['contact__phonebook__name__startswith'] = searchBoxValue;
                        if (is_completed == false) {
                            $scope.totalScheduled = 0;
                            $scope.tododata_scheduled = [];}
                        else if (is_completed == true) {
                            $scope.totalCompleted = 0;
                            $scope.tododata_completed = [];
                        }
                    }
                }
                , function(reason){
                        Loader.hide();
                        if(reason != null) {
                            $ionicPopup.alert({
                                title:    'Scheduled Calls',
                                template: 'Unable to fetch Scheduled Calls. Please check your network and try again later.'});
                        }
                });
            }
            else {
                options = {}
                options['is_completed'] = is_completed;
                options['offset'] = 0;
                options['phone__startswith'] = searchBoxValue;
                $scope.activefilters['phone__startswith'] = searchBoxValue;

                var promise = TodoService.getTodoData(options);

                promise.then(function(data) {
                        if (is_completed == false) {
                            $scope.totalScheduled = data.meta.total_count;
                            $scope.tododata_scheduled = data.response;
                             }
                        else if (is_completed == true) {
                            $scope.totalCompleted = data.meta.total_count
                            $scope.tododata_completed = data.response; }
                    },
                    function(reason) {
                        if(reason != null) {
                            $ionicPopup.alert({
                                title:    'Scheduled Calls',
                                template: 'Unable to fetch Scheduled Calls. Please check your network and try again later.'
                            });
                        }
                    });
            }
        }

        $scope.loadMore = function() {
            if ($scope.showSchedule == true) {
                var options = {}
                options['is_completed'] = false;
                options['offset'] = $scope.tododata_scheduled.length > 0 ? $scope.tododata_scheduled.length : 0;
                options = Object.assign({}, options, $scope.activefilters);

                var promise = TodoService.getTodoData(options);
                promise.then(function(data) {
                    $scope.totalScheduled = data.meta.total_count;
                    Array.prototype.push.apply($scope.tododata_scheduled, data.response);
                },
                function(reason) {
                    if(reason != null) {
                        $ionicPopup.alert({
                            title:    'Scheduled Calls',
                            template: 'Unable to fetch Scheduled Calls. Please check your network and try again later.'
                        });
                    }
                }).finally(function() {
                    $scope.$broadcast('scroll.infiniteScrollComplete');
                });
            }
            else if ($scope.showSchedule == false) {
                var options = {}
                options['is_completed'] = true;
                options['offset'] = $scope.tododata_completed.length > 0 ? $scope.tododata_completed.length : 0;
                options = Object.assign({}, options, $scope.activefilters);

                var promise = TodoService.getTodoData(options);
                promise.then(function(data) {
                    $scope.totalCompleted = data.meta.total_count;
                    Array.prototype.push.apply($scope.tododata_completed, data.response);
                    if ($scope.tododata_completed.length >= $scope.totalCompleted)  {
                        $scope.noMoreCompletedTodosAvailable = true;  }
                },
                function(reason) {
                    if(reason != null) {
                        $ionicPopup.alert({
                            title: 'Scheduled Calls',
                            template: 'Unable to fetch Scheduled Calls. Please check your network and try again later.'
                        });
                    }
                }).finally(function() {
                    $scope.$broadcast('scroll.infiniteScrollComplete');
                });
            }
        }

        $scope.onGesture = function() {
            // confirm("de");
        }

        $scope.todoRefresh = function() {
            $scope.filteredNumbers = [];

            var options = {};
            options['offset'] = 0;
            options = Object.assign({}, options, $scope.activefilters);

            if ($scope.activefilters['contact__phonebook__name__startswith']){
                var searchBoxValue = $scope.activefilters['contact__phonebook__name__startswith'];
                var promise = CustomerData.getCustomerData(0, searchBoxValue);
                promise.then(function(data)  {
                    var contacts = data.response['objects'];
                    $scope.filteredNumbers = [];
                    for (var i=0; i<contacts.length; i++) {
                        contactName = contacts[i].phonebook['name'];
                        if (contactName.toLowerCase().startsWith(searchBoxValue.toLowerCase())) {
                            $scope.filteredNumbers.push(contacts[i].phonebook.phonenumbers_set[0]['number']);
                        }}
                    if ($scope.filteredNumbers.length > 0) {
                        $scope.activefilters['phone__in']  = $scope.filteredNumbers.join(",");
                        options['phone__in']  = $scope.filteredNumbers.join(",");
                    }
                    else {
                        if ($scope.showSchedule == true) {
                            $scope.totalScheduled = 0;
                            $scope.tododata_scheduled = [];}
                        else if ($scope.showSchedule == false) {
                            $scope.totalCompleted = 0;
                            $scope.tododata_completed = []; }
                    }

                },
                function(reason) {
                    if(reason != null) {
                        $ionicPopup.alert({
                            title:    'Scheduled Calls',
                            template: 'Unable to fetch Scheduled Calls. Please check your network and try again later.'
                        });
                    }
                });
            }
            if (($scope.activefilters['contact__phonebook__name__startswith'] && $scope.filteredNumbers.length > 0) || (!$scope.activefilters['contact__phonebook__name__startswith'])){
            if ($scope.showSchedule == true) {
                options['is_completed'] = false;
                var promise = TodoService.getTodoData(options);

                promise.then(function(data) {
                    $scope.totalScheduled = data.meta.total_count;
                    $scope.tododata_scheduled = data.response;
                },
                function(reason) {
                    if(reason != null) {
                        $ionicPopup.alert({
                            title:    'Scheduled Calls',
                            template: 'Unable to fetch Scheduled Calls. Please check your network and try again later.'
                        });
                    }
                }).finally(function() {
                    $scope.$broadcast('scroll.refreshComplete'); });
            }
            else if ($scope.showSchedule == false) {
                options['is_completed'] = true;
                var promise = TodoService.getTodoData(options);

                promise.then(function(data) {
                    $scope.totalCompleted = data.meta.total_count
                    $scope.tododata_completed = data.response;
                },
                function(reason) {
                    if(reason != null) {
                        $ionicPopup.alert({
                            title:    'Scheduled Calls',
                            template: 'Unable to fetch Scheduled Calls. Please check your network and try again later.'
                        });
                    }
                }).finally(function() {
                    $scope.$broadcast('scroll.refreshComplete');
                });
            }}
        };
        $scope.toggleValue = function(value) {
            if (value == 'schedule')
                $scope.showSchedule = true;
            else
                $scope.showSchedule = false;
        }
        $scope.filterTodos = function(value) {
            if ($scope.filterTypevalue['scheduleFilter'] == 'missed') {
                return value.type != 'followup'
            } else if ($scope.filterTypevalue['scheduleFilter'] == 'followup') {
                return value.type == 'followup'
            } else return true;
        }
        $scope.filterTodosCompleted = function(value) {
            if ($scope.filterTypevalue['scheduleFilterCompleted'] == 'missed') {
                return value.type != 'followup'
            } else if ($scope.filterTypevalue['scheduleFilterCompleted'] == 'followup') {
                return value.type == 'followup'
            } else return true;
        }
        $scope.filterUnknown = function(value) {
            if (value.type == "missedcall")
                return $scope.getPhonenumber(value.contact_id, value.phone) != '';
            return $scope.getPhonenumber(value.contact_id, value.contact.phone_numbers) != '';
        }
        $scope.orderTodos = function(value) {
            if (value.type == 'followup')
                return value.duedate;
            else
                return value.call_missed_dt;
        }
        $scope.refineTodos = function(todo) {
            if (todo.duedate && todo.type == 'followup') {
                if (todo.duedate.length > 4)
                    return true
            } else if (todo.type != 'followup' && todo.call_missed_dt != 'None')
                return true;
            return false;
        }
    })
    // Accounts controller
    .controller('accountsCtrl', function($scope, AccountService, $ionicPopup, AuthService) {
        $scope.ownerChoice = {
            'missedCall':{
                'value': ''
            },
            'followup':{
                'value': ''
            },
            'record_sync_mobile_calls':{
                'value': ''
            }
        }
        $scope.agentChoice = {
            'missedCall':{
                'value': ''
            },
            'followup':{
                'value': ''
            },
            'record_sync_mobile_calls':{
                'value': ''
            }
        }
        $scope.accountFilterModal = {
            'value': ''
        }
        $scope.settingList = {
            'notify_agent_for_task': {
                'model' :'$scope.agentChoice.missedCall.value=$scope.displayChoices[arr[i].setting_value];',
                'filter': '$scope.accountFilterModal = $scope.agentChoice.missedCall;'
            },
            'notify_owner_tasks_missed_new': {
                'model': '$scope.ownerChoice.missedCall.value=$scope.displayChoices[arr[i].setting_value];',
                'filter': '$scope.accountFilterModal = $scope.ownerChoice.missedCall;'
            },
            'notify_agent_followups': {
                'model': '$scope.agentChoice.followup.value=$scope.displayChoices[arr[i].setting_value];',
                'filter': '$scope.accountFilterModal = $scope.agentChoice.followup;'
            },
            'notify_owner_followups': {
                'model': '$scope.ownerChoice.followup.value=$scope.displayChoices[arr[i].setting_value];',
                'filter': '$scope.accountFilterModal = $scope.ownerChoice.followup;'
            },
            'record_sync_mobile_calls_owner': {
                'model' :'$scope.ownerChoice.record_sync_mobile_calls.value=$scope.displayChoicesSyncSettings[arr[i].setting_value];',
                'filter': '$scope.accountFilterModal = $scope.ownerChoice.record_sync_mobile_calls;'
            },
            'record_sync_mobile_calls_agent': {
                'model' :'$scope.agentChoice.record_sync_mobile_calls.value=$scope.displayChoicesSyncSettings[arr[i].setting_value];',
                'filter': '$scope.accountFilterModal = $scope.agentChoice.record_sync_mobile_calls;'
            }
        }
        $scope.displayChoices = {
            'always': 'Always',
            'eod': 'EOD',
            'noon': 'SOD',
            'hourly': 'Hourly',
            'false': 'Never',
            'crm': 'CRM'
        }
        $scope.reverseDisplayChoices = {
            'Always': 'always',
            'EOD': 'eod',
            'SOD': 'noon',
            'Hourly': 'hourly',
            'Never': 'false',
            'CRM' : 'crm'
        }

        $scope.displayChoicesSyncSettings = {
            'always': 'CRM',
            'false': 'Never',
            'always_all': 'All'
        }
        $scope.reverseDisplayChoicesSyncSettings = {
            'CRM': 'always',
            'Never': 'false',
            'All' : 'always_all'
        }

        var promise = AccountService.getAccountData();
        promise.then(function(data){
            $scope.acc_data = data.response.objects;
            var arr = data.response.objects, len = arr.length, i = 0;
            for (;i < len; i++) {
                if (arr[i].setting_name && $scope.settingList[arr[i].setting_name]){
                    eval($scope.settingList[arr[i].setting_name]['model'])
                }
            }
        }, function(error){
            $ionicPopup.alert({
                title: 'Account',
                template: error + ''
            });
        }).finally(function(){
            $scope.$broadcast('scroll.refreshComplete');
        });
        $scope.saveAccountInfo = function(type, templateUrl) {
            eval($scope.settingList[type]['filter']);
            $ionicPopup.confirm({
                templateUrl: templateUrl,
                scope: $scope,
                buttons: [{
                    text: 'Apply',
                    type: 'button-positive',
                    onTap: function(e) {
                        var arr = $scope.acc_data, len = arr.length, i = 0, settingExists = false;
                        for (;i < len; i++) {
                            if (type ==  arr[i].setting_name){
                                settingExists = true
                                if(arr[i].setting_name == "record_sync_mobile_calls_owner" ||
                                    arr[i].setting_name == "record_sync_mobile_calls_agent" ){
                                    arr[i].setting_value = $scope.reverseDisplayChoicesSyncSettings[$scope.accountFilterModal.value];
                                }
                                else
                                {
                                    arr[i].setting_value = $scope.reverseDisplayChoices[$scope.accountFilterModal.value];
                                }
                                var promise = AccountService.saveAccountData(arr[i], 'PUT');
                                var eventBatch = AuthService.createEventPacket(
                                    'app_authentication',
                                    'app_settings',
                                    'setting_change',
                                    'success',
                                    JSON.stringify(arr[i]),
                                    []
                                );
                                AuthService.captureEvent(eventBatch)
                                .then(function(data){
                                    console.log('submit change setting event : '+ data + Date.now());
                                });
                                break;
                            }
                        }
                        if (!settingExists){
                            var acc_obj = {
                                "resource_uri": "/newsr/api/v1/app_settings/",
                                "setting_name": type,
                                "setting_value": $scope.reverseDisplayChoices[$scope.accountFilterModal.value]
                            }
                            var promise = AccountService.saveAccountData(acc_obj, 'POST');
                            var eventBatch = AuthService.createEventPacket(
                                'app_authentication',
                                'app_settings',
                                'setting_change',
                                'success',
                                JSON.stringify(acc_obj),
                                []
                            );
                            AuthService.captureEvent(eventBatch)
                            .then(function(data){
                                console.log('submit change setting event : '+ data + Date.now());
                            });
                        }
                    }
                }]
            });
        }
    })
    // Settings screen controller
    .controller('settingsCtrl', function($scope, CreditsService, AuthService, GoogleAnalytics, $ionicPopup, $ionicHistory) {
        $scope.$on('$ionicView.enter', function() {
            GoogleAnalytics.screenView('Settings');
        });
        $ionicHistory.clearHistory();
        $scope.platform = (AuthService.getUserCredentials()).userplatform;
        $scope.customerCareNumber = '1-800-419-0333';

        var defaultCustomerCountry = (AuthService.getUserCredentials())['country_of_operation'];
        if(defaultCustomerCountry == 'Singapore'){
            $scope.customerCareNumber = '+65-315-85-434';
        }
        else if(defaultCustomerCountry == 'Philippines'){
            $scope.customerCareNumber = '+63-264-06-899';
        }
        else if(defaultCustomerCountry == 'United Arab Emirates'){
            $scope.customerCareNumber = '+971-455-08-331';
        }
        else if(defaultCustomerCountry == 'Thailand'){
            $scope.customerCareNumber = '+66-208-03-980';
        }
        var promise = CreditsService.getCredits();
        promise.then(function(data) {
            $scope.showCredit = data.response;
        }, function(error) {
            $ionicPopup.alert({
                title: 'Credits',
                template: error + ''
            });
        }).finally(function() {});
        $scope.customerCare = function() {

            window.open('tel:'+$scope.customerCareNumber);
            GoogleAnalytics.sendEvent("Call Btn-Click(1-800-419-0333)", 'Customer Call Btn-Click', 'Customer Call Button via Settings screen');
        }
        $scope.refreshCoins = function() {
            var promise = CreditsService.getCredits();
            promise.then(function(data) {
                $scope.showCredit = data.response;
            }, function(error) {
                $ionicPopup.alert({
                    title: 'Credits',
                    template: error + ''
                });
            }).finally(function() {
                $scope.$broadcast('scroll.refreshComplete');
            });
        }
    })
    // Insights
    .controller('insightsCtrl', function($scope, InsightScreen, Geographydata, GoogleAnalytics, $ionicHistory, $ionicPopup) {
        $scope.$on('$ionicView.enter', function() {
            GoogleAnalytics.screenView('Insights');
        });
        $ionicHistory.clearHistory();
        $scope.callinsightVisibility = true;
        $scope.visibility = true;
        // $scope.getInsightslocation = function() {
        //         var promise = Geographydata.getGeographydata();
        //         promise.then(function(data) {
        //             var fetch = data.fetch;
        //             var l = fetch.meta.total_count;
        //             $scope.visibility = l >= 1 ? true : false;
        //             var totalsum = 0;
        //             var map = {};
        //             for (var j = 0; j < l; j++) {
        //                 if ((map[fetch.objects[j].location]) == null)
        //                     map[fetch.objects[j].location] = fetch.objects[j].total_call;
        //                 else
        //                     map[fetch.objects[j].location] = map[fetch.objects[j].location] + fetch.objects[j].total_call;
        //                 totalsum = totalsum + fetch.objects[j].total_call;
        //             }
        //             var keys = Object.keys(map);
        //             $scope.labels = keys;
        //             $scope.data = keys.map(function(v) {
        //                 return map[v];
        //             });
        //             for (var j = 0; j < l; j++)
        //                 $scope.data[j] = Math.round(($scope.data[j] / totalsum) * 100);
        //             $scope.map = map
        //             $scope.totalsum = totalsum;
        //         }, function(error) {
        //             $scope.visibility = 0;
        //             $ionicPopup.alert({
        //                 title: 'Insights',
        //                 template: error + ''
        //             });
        //         })
        //     }
            // Global + Custom Chart Config Options
        var options = {
            bezierCurve: false,
            animation: true,
            animationEasing: "easeOutQuart",
            showScale: false,
            tooltipEvents: ["mousemove", "touchstart", "touchmove"],
            tooltipCornerRadius: 3,
            pointDot: true,
            pointDotRadius: 4,
            datasetFill: true,
            scaleShowLine: true,
            animationEasing: "easeOutBounce",
            animateRotate: true,
            animateScale: true,
        };
        var ctx = document.getElementById("myDonutChart").getContext("2d");
        var ctx1 = document.getElementById("myDonutChart2").getContext("2d");
        var promise = InsightScreen.insightscreen();
        promise.then(function(data) {
            /*$scope.newpercent = Math.round((data.totalcallsum / data.totalcalldata_sum) * 100);
            $scope.returnpercent = (100 - $scope.newpercent);*/
            /*$scope.ougoing = Math.round((data.missed_calls / (data.missed_calls + data.answered_calls)) * 100);
            $scope.incoming = 100 - $scope.ougoing;*/
            $scope.ougoing = Math.round((data.outgoing / data.totalcalldata_sum ) * 100);
            $scope.incoming = 100 - $scope.ougoing;
            $scope.missed_calls = Math.round((data.missed_calls / data.totalcalldata_sum ) * 100);
            $scope.phone = Math.round((data.phone / data.totalcalldata_sum ) * 100);
            $scope.no_input = Math.round((data.no_input / data.totalcalldata_sum ) * 100);
            $scope.DTMF = Math.round((data.DTMF / data.totalcalldata_sum ) * 100);
            $scope.sound = Math.round((data.sound / data.totalcalldata_sum ) * 100);
            $scope.call_group = Math.round((data.call_group / data.totalcalldata_sum ) * 100);
            $scope.DNP = Math.round((data.DNP / data.totalcalldata_sum ) * 100);
            $scope.Voicemail = Math.round((data.Voicemail / data.totalcalldata_sum ) * 100);
            $scope.callinsightVisibility = data.totalcalldata_sum >= 1 ? true : false;
            /*$scope.newpercent = isNaN($scope.newpercent) ? 0 : $scope.newpercent;
            $scope.returnpercent = isNaN($scope.returnpercent) ? 0 : $scope.returnpercent;*/
            $scope.ougoing = isNaN($scope.ougoing) ? 0 : $scope.ougoing;
            $scope.incoming = isNaN($scope.incoming) ? 0 : $scope.incoming;
            $scope.missed_calls = isNaN($scope.missed_calls) ? 0 : $scope.missed_calls;
            $scope.phone = isNaN($scope.phone) ? 0 : $scope.phone;
            $scope.no_input = isNaN($scope.no_input) ? 0 : $scope.no_input;
            $scope.DTMF = isNaN($scope.DTMF) ? 0 : $scope.DTMF;
            $scope.sound = isNaN($scope.sound) ? 0 : $scope.sound;
            $scope.call_group = isNaN($scope.call_group) ? 0 : $scope.call_group;
            $scope.DNP = isNaN($scope.DNP) ? 0 : $scope.DNP;
            $scope.Voicemail = isNaN($scope.Voicemail) ? 0 : $scope.Voicemail;

            $scope.outgoingVisibility = $scope.ougoing >= 1 ? true : false;
            $scope.incomingVisibility = $scope.incoming >= 1 ? true : false;
            $scope.missed_callsVisibility = $scope.missed_calls >= 1 ? true : false;
            $scope.phoneVisibility = $scope.phone >= 1 ? true : false;
            $scope.no_inputVisibility = $scope.no_input >= 1 ? true : false;
            $scope.DTMFVisibility = $scope.DTMF >= 1 ? true : false;
            $scope.soundVisibility = $scope.sound >= 1 ? true : false;
            $scope.call_groupVisibility = $scope.call_group >= 1 ? true : false;
            $scope.DNPVisibility = $scope.DNP >= 1 ? true : false;
            $scope.VoicemailVisibility = $scope.Voicemail >= 1 ? true : false;

            var data2 = [{
                value: data.missed_calls,
                color: "#F7464A",
                highlight: "#FF5A5E",
                label: "Missed Calls"

            }, {

                value: data.phone,
                color: "#4D5360",
                highlight: "#616774",
                label: "Phone"

            }, {

                value: data.no_input,
                color: "#FFA500",
                highlight: "#FFA500",
                label: "NO INPUT"

            }, {

                value: data.DTMF,
                color: "#008000",
                highlight: "#008000",
                label: "DTMF"

            }, {

                value: data.sound,
                color: "#0000FF",
                highlight: "#0000FF",
                label: "Sound"

            }, {

                value: data.call_group,
                color: "#FFC0CB",
                highlight: "#FFC0CB",
                label: "Call Group"

            }, {

                value: data.DNP,
                color: "#87CEEB",
                highlight: "#87CEEB",
                label: "DNP"

            }, {

                value: data.Voicemail,
                color: "#BDB76B",
                highlight: "#BDB76B",
                label: "Voicemail"

            }];
            var data3 = [{
                value: data.outgoing,
                color: "#F7464A",
                highlight: "#FF5A5E",
                label: "Outgoing"

            }, {

                value: data.incoming,
                color: "#4D5360",
                highlight: "#616774",
                label: "Incoming"

            }];
            var myDoughnutChart = new Chart(ctx).Doughnut(data2, options);
            var myDoughnutChart2 = new Chart(ctx1).Doughnut(data3, options);
        }, function(error) {
            $scope.callinsightVisibility = false;
            $ionicPopup.alert({
                title: 'insights',
                template: error + ''
            });
        })
    })
    .controller('SrLoginCtrl', function($scope, AuthService, $ionicPopup,
        $window, $rootScope, ionicToast, GoogleAnalytics, $state, $location,
        GetAgents, Loader, _ENV, $ionicModal, TnCService) {

        $rootScope.$on('No_Network', function() {
            ionicToast.show('Check Network Connection', 'middle', false, 1000);
        });
        $ionicModal.fromTemplateUrl('templates/modal/open-settings.html', {
            scope: $rootScope,
            animation: 'slide-in-up'
        }).then(function(modal) {
            $rootScope.settingModal = modal;
        });
        $rootScope.openSettingModal = function() {
            $rootScope.settingModal.show();
        };

        $rootScope.closeSettingModal = function() {
            $rootScope.settingModal.hide();
        };

        $rootScope.gotoSettings = function() {
            if (window.cordova && window.cordova.plugins.settings) {
                console.log('openNativeSettingsTest is active');
                window.cordova.plugins.settings.open("application_details",
                    function() {
                        console.log('opened application_details');
                    },
                    function () {
                        console.log('failed to open application_details');
                    });
            } else {
                console.log('openNativeSettingsTest is not active!');
            }
        };
        $scope.loginflag = false;
        $scope.Login = function(credentials) {
            $scope.loginflag = true;
            if (!credentials) {
                $ionicPopup.alert({
                    title: 'Login Failed',
                    template: 'Please enter valid username/password'
                });
                $scope.loginflag = false;
            } else {
                Loader.show();
                var promise = AuthService.login(credentials);
                promise.then(function(data) {
                    GetAgents.agents(data).then(function() {
                        GoogleAnalytics.sendEvent("Logged in", "Login click", "logged successfully");

                        var promise = AuthService.changeStatus("Available");
                        promise.then(function(data) {
                            console.log("Status:",JSON.stringify(data));
                            if (data['status'] && data['status'] != 'undefined') {
                                if (data['status'].indexOf("Break") > 0 && AuthService.getBreakList() != null)
                                    $rootScope.seletestatus = ("On Break : "+ data['status']);
                                else
                                    $rootScope.seletestatus = (data['status']);
                            }
                            GetAgents.getAgentStatus(AuthService.getUserCredentials());
                        },
                        function(reason) {
                            console.log('Failed to update status ' + reason);
                        });

                        if(window.cordova && ionic.Platform.isAndroid()) {
                            var eventBatch = AuthService.createEventPacket('app_authentication', 'app_login', 'login', 'success', JSON.stringify(data), []);
                            var userType = "Unknown"
                            AuthService.captureEvent(eventBatch).then(function(){                   
                                $scope.checkTnCStatus(data);                
                                $window.localStorage.setItem('firstLogin', 1);
                            });
                            $rootScope.db.transaction(function(tx) {
                                tx.executeSql('INSERT INTO LoginLogoutTable VALUES(?,?) ', [Date.now(),0]);
                            }, function(error) {
                                console.log('error in storing login time : ' + error.message);
                            }, function() {
                                console.log('inserted login time successfully : '+Date.now());
                            });
                            // code for goto setting screen for Xiaomi device
                            //To assign the information about device 
                            $rootScope.deviceInformation = ionic.Platform.device();
                            //Array of all the manufactures for which we need to show the goto settings page
                            $rootScope.manufactureNames = ["xiaomi"];
                            //Manufacure of the device
                            $rootScope.manufacturer = $rootScope.deviceInformation.manufacturer.toLowerCase();
                            console.log($rootScope.deviceInformation.manufacturer.toLowerCase());
                        
                            if ($rootScope.manufactureNames.indexOf($rootScope.manufacturer) >= 0) {
                                $rootScope.openSettingModal();
                            } 
                            
                            record_sync_mobile_calls = data['record_sync_mobile_calls'] || 'all';
                            console.log("record_sync_mobile_calls : " + record_sync_mobile_calls);
                            if (record_sync_mobile_calls.indexOf('false') == -1) {
                                
                                var eventPlugin = new EventPlugin();
                                eventPlugin.login(
                                    'Call listener enabled!',
                                    function(msg) {
                                        console.log(msg);
                                    },
                                    function(err) {
                                        console.log(err);
                                    }
                                );    
                            }
                        } else {
                            $scope.checkTnCStatus(data);
                            $window.localStorage.setItem('firstLogin', 1);
                        }
                    });
                },
                function(reason) {
                    $ionicPopup.alert({
                        title: 'Login Failed',
                        template: reason
                    });
                    $scope.loginflag = false;
                })
                .then(function() {
                    Loader.hide();
                });
            }
        };
        $scope.passwordShow = false;
        $scope.togglePasswordShow = function() {
            $scope.passwordShow = !$scope.passwordShow;
        };
        $scope.createAccount = function() {
            location.href = '#/phoneverification';
        }
        $scope.signUp = function() {
            $state.go('signUp');
        };

        $scope.checkTnCStatus = function(rootdata) {
            if (rootdata.is_owner) {
                var promise = TnCService.getTnCStatus();
                promise.then(function(data) {
                    if (!data.user_is_terms_accepted) {
                        location.href = '#/terms_and_conditions';
                        return;        
                    } 
                },
                function(reason) {
                    ionicToast.show('Failed to get TnC status ' + reason, 'middle', false, 1000);
                });
            } 
            $rootScope.performDeeplink(rootdata);
        }

        $rootScope.performDeeplink = function(data){
            var deeplink_temp = window.localStorage.getItem('deeplink_route');
            if (data.is_owner) {
                window.localStorage.setItem('deeplink_route', null);
                if (deeplink_temp != null && deeplink_temp != 'undefined')
                    location.href = '#/app/' + deeplink_temp;
                else
                    location.href = '#/app/calls';
            } else {
                window.localStorage.setItem('deeplink_route', null);
                if (deeplink_temp != null && deeplink_temp != 'undefined')
                    location.href = '#/app/' + deeplink_temp;
                else
                    location.href = '#/app/calls';
            }
        }
    })
    // forgot pasword controller
    .controller('frgtCtrl', function($scope, $stateParams, ForgotService, $rootScope, ionicToast, GoogleAnalytics) {
        $scope.submitButtonStatus = true;
        $scope.$on('$ionicView.enter', function() {
            GoogleAnalytics.screenView('Forgot password');
        });
        $rootScope.$on('No_Network', function() {
            ionicToast.show('Check Network Connection', 'middle', false, 1000);
        });
        $scope.fgtPwd = function(email) {
            ForgotService.getPassword(email);
        }
        $scope.emailChange = function(){
            var re = /^(([^<>()\[\]\\.,;:\s@"]+(\.[^<>()\[\]\\.,;:\s@"]+)*)|(".+"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/;
            var result = re.test($scope.email);
            if(result){
                $scope.submitButtonStatus = false;
            }
            else
            {
                $scope.submitButtonStatus = true;
            }
        }
    })
    // request demo controler
    .controller('requestCtrl', function($scope, $window, $http, $stateParams, ForgotService, $rootScope, countryCodevalues, ionicToast, GoogleAnalytics, getTelcoCircle) {
        $scope.$on('$ionicView.enter', function() {
            GoogleAnalytics.screenView('Request Demo');
        });
        $rootScope.$on('No_Network', function() {
            ionicToast.show('Check Network Connection', 'middle', false, 1000);
        });
        $scope.data = {};
        $scope.data.name = '';
        $scope.data.email = '';
        $scope.data.number = '';
        $scope.data.designation = 'Business Owner';
        $scope.emailStatus  = true;
        $scope.nameStatus   = true;
        $scope.numberStatus = true;
        $scope.countryCodes = countryCodevalues;
        $scope.emailChange = function(email){
            var re = /^(([^<>()\[\]\\.,;:\s@"]+(\.[^<>()\[\]\\.,;:\s@"]+)*)|(".+"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/;
            var result = re.test(email);
            if(result)
                $scope.emailStatus = false;
            else
                $scope.emailStatus = true;
        };

        $scope.nameChange = function(name){
            if (name)
                $scope.nameStatus = false;
            else
                $scope.nameStatus = true;
        };

        $scope.numberChange = function(number){
            if (number)
                $scope.numberStatus = false;
            else
                $scope.numberStatus = true;
        };

        $scope.get_lead_id = function(number, fnc){

            var parameters = {
                'authtoken': '4a4f9959c5b1d8750b9da2c818492f4b',
                'scope'    : 'crmapi',
                'criteria'  : '((Mobile:' + number + ') or (Work Phone:' + number + ') or (OTHER PHONE:' + number + '))'
            };

            $http({
                method: 'GET',
                url: 'https://crm.zoho.com/crm/private/json/Leads/searchRecords',
                params: parameters
            })
            .success(function(data) {
                var result = data["response"]["result"]["Leads"]["row"];
                // 'result' is an array if more than one result is returned else a dictionary
                if (result.constructor.name == "Array")
                {
                    var final_result = result[0];
                }
                else
                {
                    var final_result = result;
                }
                fnc(final_result["FL"][0]["content"]);
            })
            .error(function(msg, code) {
                $window.location.href = '#/requestdemo_failure';
            });

        }

        $scope.submitButtonStatus = false;


        $scope.update_lead = function(lead_id, name, email, designation) {
            var parameters = {
                'authtoken': '4a4f9959c5b1d8750b9da2c818492f4b',
                'scope'    : 'crmapi',
                'xmlData'  : '<Leads><row no="1"><FL val="Title"><![CDATA[' + designation + ']]></FL><FL val="Product"><![CDATA[SR]]></FL><FL val="Lead Status">Contacted-Callback</FL><FL val="Telco Circle"><![CDATA['+ $scope.caller_circle + ']]></FL><FL val="Last Name"><![CDATA[' + name + ']]></FL><FL val="Email"><![CDATA[' + email + ']]></FL><FL val="solution_type"><![CDATA[mobile]]></FL></row></Leads>',
                'id'       : lead_id
            };

            $http({
                method: 'GET',
                url: 'https://crm.zoho.com/crm/private/xml/Leads/updateRecords',
                params: parameters
            })
            .success(function(data) {
                $window.location.href = '#/requestdemo_success';
            })
            .error(function(msg, code) {
                $window.location.href = '#/requestdemo_failure';
            });
        };

        $scope.submitRequest = function(name, email, number_prefix, number, designation){
            //send ajax request
            //on success redirect to success page
            //else redirect to failure page
            // $window.location.href = '#/requestdemo_failure';

            if (typeof(name) == 'undefined' || typeof(email) == 'undefined' || typeof(number_prefix) == 'undefined' || typeof(number) == 'undefined' ) {
                $window.location.href = '#/requestdemo_failure';
            } else {
                var isValid = $window.phoneUtils.isValidNumberForRegion(number.toString(), number_prefix['countryCode']);
                if (!isValid) {
                    ionicToast.show('Check the number you have entered!', 'middle', false, 1000);
                    return;
                }
                if (!$rootScope.online) {
                    ionicToast.show('Check Internet connection!', 'middle', false, 1000);
                    return;
                }

                //get the caller circle from the leads phone number
                $scope.caller_circle_promise = getTelcoCircle.get_telco_circle(number);
                $scope.caller_circle_promise.then(function(data)
                {
                    $scope.caller_circle = data;
                });
                var xmlParameters = '<?xml version="1.0"?><Leads><row no="1"><FL val="Last Name"><![CDATA[' + name + ']]></FL><FL val="Mobile"><![CDATA[' +
                number_prefix.code + number + ']]></FL><FL val="Email"><![CDATA[' + email +
                 ']]></FL><FL val="Lead Source"><![CDATA[Organic]]></FL><FL val="Sub-Source"><![CDATA[Website]]></FL><FL val="Title"><![CDATA[' + designation + ']]></FL><FL val="Source"><![CDATA[Organic]]></FL><FL val="Product"><![CDATA[SR]]></FL><FL val="Telco Circle"><![CDATA['+ $scope.caller_circle + ']]></FL><FL val="Mode"><![CDATA[MobileApp]]></FL><FL val="solution_type"><![CDATA[mobile]]></FL></row></Leads>';
                var parameters = {
                    'authtoken': '4a4f9959c5b1d8750b9da2c818492f4b',
                    'scope'    : 'crmapi',
                    'xmlData'  : xmlParameters,
                    'wfTrigger': true
                };
                $http({
                    method: 'GET',
                    url: 'https://crm.zoho.com/crm/private/xml/Leads/insertRecords',
                    params: parameters
                })
                .success(function(data) {
                    // Reset form values
                    $scope.data.name = '';
                    $scope.data.email = '';
                    $scope.data.number = '';
                    $scope.data.designation = 'Business Owner';

                    // Check if the response contains error
                    parser = new DOMParser();
                    xmlDoc = parser.parseFromString(data,"text/xml");
                    if (xmlDoc.getElementsByTagName('error').length > 0)
                    {
                        $scope.get_lead_id(number, function(returnvalue){
                            $scope.update_lead(returnvalue, name, email, designation);
                        });
                    }
                    else {
                        // Go to success page
                        $window.location.href = '#/requestdemo_success';
                    }
                })
                .error(function(msg, code) {
                    $window.location.href = '#/requestdemo_failure';
                });
            }
        }
    })
    .controller('onBoardCtrl', function($scope, $stateParams, ForgotService, GoogleAnalytics) {
        $scope.$on('$ionicView.enter', function() {
            GoogleAnalytics.screenView('On Board ');
        });
    })
    // controller for add new contact
    .controller('newcontactCtrl', function($scope, $stateParams, SaveContact, $rootScope, $ionicPopup, countryCodevalues, $ionicModal, IonicClosePopupService, $timeout, Loader, GoogleAnalytics) {
        $scope.$on('$ionicView.enter', function() {
            GoogleAnalytics.screenView('Add contact');
        });
        $scope.leadStatus = ["Hot", "Warm", "Cold", "Closed"];
        $scope.scheduleoptions = ["All", "Missed", "Scheduled"];
        // country code ionic modal
        $scope.phonecodes = countryCodevalues;
        $ionicModal.fromTemplateUrl('countryCode.html', {
            scope: $scope,
            animation: 'slide-in-up'
        }).then(function(modal) {
            $scope.modal = modal;
        });
        $scope.contact = { country_Code: '+91', countryCode: '+91' };
        $scope.openModal = function() {
            $scope.contact.country_Code = $scope.contact.countryCode
            $scope.modal.show();
        };
        $scope.closeModal = function() {
            $scope.modal.hide();
        };
        $rootScope.setCountryCode = function() {
            $scope.contact.countryCode = $scope.contact.country_Code;
            $scope.closeModal();
        }
        $scope.newcontactpopup = function(screenname) {
                // var filterType = screenname.split('.')[0];
                // $scope.choice = {value: $scope.filterTypevalue[filterType]};
                $ionicPopup.confirm({
                    templateUrl: screenname,
                    scope: $scope,
                    buttons: [{
                        text: 'Apply',
                        type: 'button-positive',
                        onTap: function(e) {}
                    }]
                });
            }
            // save new contact screen
        $scope.savenewContact = function() {
            name = angular.element(document.querySelector('#newnames')).val();
            countryCode = angular.element(document.querySelector('#newCode')).val();
            number = angular.element(document.querySelector('#newnumber')).val();
            company = angular.element(document.querySelector('#newcompany')).val();
            status = $scope.fillfields.status1;
            if (countryCode)
                number = countryCode + number;
            var promise = SaveContact.savenewContact(name, number, company, status, $scope.fillfields.id1, $scope.value.followupData, $scope.existing, " ");
            promise.then(function(data) {
                GoogleAnalytics.sendEvent("Contact", "Add contact", "Added contact from contacts screen");
                responsedata = data.response;
                $rootScope.addcontactsData(responsedata);
                $rootScope.customers.push(responsedata);
                $rootScope.value = { "name": responsedata['phonebook']['name'], "company": responsedata['phonebook']['company'], "contactnumber": responsedata['phonebook']['phonenumbers_set'][0]['number'], "status": responsedata.status, "id": responsedata.id, "followupData": responsedata.followupData };
            }, function(error) {
                if (error.status.duplicates) {
                    $ionicPopup.alert({
                        title: 'Contact',
                        template: 'Duplicate contact number '
                    });
                } else {
                    $ionicPopup.alert({
                        title: 'Contact',
                        template: error
                    });
                }
            });
        }
    })
    .controller('updateCtrl', function($scope, $stateParams, SaveContact, $rootScope, $ionicPopup, countryCodevalues, $ionicModal, IonicClosePopupService, $timeout, Loader, GoogleAnalytics) {
        $scope.$on('$ionicView.enter', function() {
            GoogleAnalytics.screenView('Update contact');
        });
        var sourceScreen = $rootScope.customerdetail_source_screen;
        $scope.leadStatus = ["Hot", "Warm", "Cold", "Closed"];
        // save new contact screen
        $scope.savenewContact = function() {
            name = angular.element(document.querySelector('#newnames')).val();
            number = angular.element(document.querySelector('#newnumber')).val();
            company = angular.element(document.querySelector('#newcompany')).val();
            status = $scope.fillfields.status1;
            var promise = SaveContact.savenewContact(name, number, company, status, $scope.fillfields.id1, $scope.value.followupData, $scope.existing, " ");
            promise.then(function(data) {
                GoogleAnalytics.sendEvent("Contact", "Edit Contact", "Edited contact from profile tab on contact details via " + sourceScreen + " screen");
                responsedata = data.response;
                $rootScope.addcontactsData(responsedata);
                // $rootScope.customers.push(responsedata);
                $rootScope.unknownCaller[$scope.value.contactnumber] = data.response.id;
                $rootScope.value = { "name": responsedata['phonebook']['name'], "company": responsedata['phonebook']['company'], "contactnumber": responsedata['phonebook']['phonenumbers_set'][0]['number'], "status": responsedata.status, "id": responsedata.id, "followupData": responsedata.followupData };
            }, function(error) {
                if (error.status.duplicates) {
                    $ionicPopup.alert({
                        title: 'Contact',
                        template: 'Duplicate contact number '
                    });
                } else {
                    $ionicPopup.alert({
                        title: 'Contact',
                        template: error
                    });
                }
            });
        }
    })
    .controller('webCallListCtrl', function($scope, $rootScope, CallLogService, $ionicPopup, Loader, ionicToast, $cordovaMedia, GoogleAnalytics, $ionicHistory) {
        $ionicHistory.clearHistory();
        $scope.webcalls = [];
        $scope.$watch('webcalls', function() {
            if ($scope.webcalls.length == $scope.webcallLogCount) {
                $scope.noMoreWebCallLogsAvailable = true;
            }
        });
        if ($rootScope.internet == 1) {
            $scope.$watch('webcallReceived', function() {
                $scope.webcallReceived == false ? Loader.show() : Loader.hide();
            });
        }
        $scope.title = "Web Calls";
        $scope.noMoreWebCallLogsAvailable = false;
        $scope.webcallReceived = false;
        var promise = CallLogService.getWebCallList();
            promise.then(function(data) {
                $scope.webcallReceived = true;
                    for (var i=0;i<data.objects.length ;i++) {
                        var callerph = data.objects[i].contact_number;
                        $scope.webcalls.push(
                            {'callerph' : callerph,'is_read' : data.objects[i].status,'call_id':data.objects[i].id});
                    }
                },
                function(reason) {
                    $scope.webcallReceived = true
                    $ionicPopup.alert({
                        title: 'Web Call Logs',
                        template: 'Please check your network and try again later.'
                    });
                });

        $scope.loadMore = function() {
            var promise = CallLogService.getWebCallList($scope.webcalls.length+1);
            promise.then(function(data) {

                for (var i=0;i<data.objects.length ;i++) {
                        var callerph = data.objects[i].contact_number;
                        $scope.webcalls.push(
                            {'callerph' : callerph,'is_read' : data.objects[i].status,'call_id':data.objects[i].id});
                    }
                },
                function(reason) {
                    $ionicPopup.alert({
                        title: 'Web Call Logs',
                        template: 'Please check your network and try again later.'
                    });
                }).finally(function() {
                $scope.$broadcast('scroll.infiniteScrollComplete');
            });
        };

        $scope.called = function(id){
            var promise = CallLogService.markCalled(id);
            promise.then(function(data) {
                    console.log('marked called success id'+id);
                },
                function(reason) {
                    console.log('marked called failure id :'+id);

                });
        };

        $scope.refreshButton = function(){
            Loader.show();
            var promise = CallLogService.getWebCallList(0);
            promise.then(function(data) {
                    $scope.webcalls = [];
                    for (var i=0;i<data.objects.length ;i++) {
                        var callerph = data.objects[i].contact_number;
                        $scope.webcalls.push(
                            {'callerph' : callerph,'is_read' : data.objects[i].status,'call_id':data.objects[i].id});
                    }
                },
                function(reason) {
                    $ionicPopup.alert({
                        title: 'Web Call Logs',
                        template: 'Please check your network and try again later.'
                    });
                }).finally(function() {
                    Loader.hide();
                });
        }

        $scope.doRefresh = function(){
            var promise = CallLogService.getWebCallList(0);
            Loader.show();
            promise.then(function(data) {
                    $scope.webcalls = [];
                    for (var i=0;i<data.objects.length ;i++) {
                        var callerph = data.objects[i].contact_number;
                        $scope.webcalls.push(
                            {'callerph' : callerph,'is_read' : data.objects[i].status,'call_id':data.objects[i].id});
                    }
                },
                function(reason) {
                    $ionicPopup.alert({
                        title: 'Web Call Logs',
                        template: 'Please check your network and try again later.'
                    });
                }).finally(function() {
                    Loader.hide();
                    $scope.$broadcast('scroll.refreshComplete');
                });
        };
    })
    .controller('resetPasswordCtrl', function($scope, $stateParams, $rootScope, ionicToast, GoogleAnalytics, $location, $ionicPopup, $http, Loader, $window, resetPasswordService){
        $scope.uidb36 = $location.search()['uidb36']
        $scope.token = $location.search()['token']
        $scope.loginData = {};
        $scope.loginData.reset_password_1 = '';
        $scope.loginData.reset_password_2 = '';
        $scope.reset_password_show_1 = false;
        $scope.reset_password_show_2 = false;
        $scope.submitButtonStatus = true;
        $scope.togglePasswordShow = function(t) {
            if (t == 'reset_password_1')
                $scope.reset_password_show_1 = !$scope.reset_password_show_1
            else if (t == 'reset_password_2')
                $scope.reset_password_show_2 = !$scope.reset_password_show_2
        };
        $scope.passwordChange = function(t) {
            $scope.submitButtonStatus = true;
            reset_password_1 = $scope.loginData.reset_password_1;
            reset_password_2 = $scope.loginData.reset_password_2;
            reset_password_1_trim = reset_password_1.trim();
            reset_password_2_trim = reset_password_2.trim();
            if (reset_password_1 && reset_password_1_trim && reset_password_2 && reset_password_2_trim) {
                if (reset_password_1 == reset_password_2) {
                    $scope.submitButtonStatus = false;
                }
            }
        }
        $scope.resetPassword = function() {
            var uidb36, token, data, promise;
            uidb36 = $scope.uidb36;
            token = $scope.token;
            data = {
                'new_password1': $scope.loginData.reset_password_1,
                'new_password2': $scope.loginData.reset_password_2
            };
            promise = resetPasswordService.reset(uidb36, token, data);
            Loader.show();
            promise.then(function(data) {
                ionicToast.show('Password successfully changed. Redirecting to Login page!', 'middle', false, 2000);
                $window.location.href = '#/srlogin';
            }, function(error) {
                $ionicPopup.alert({
                    title: 'Password reset failed.',
                    template: error
                });
            })
            .finally(function() {
                Loader.hide();
            });
        }
    })