angular.module('starter.factory', [])
    .factory('JsonToFormdata', function() {
        var Jsonservice = {};
        Jsonservice.convert = function(obj) {
            var p = [];
            for (var key in obj) {
                p.push(key + '=' + encodeURIComponent(obj[key]));
            }
            return p.join('&');
        };
        return Jsonservice;
    })
    .factory('ApiCall', function(AuthService) {
        var apicall = {};
        var userCredentials = AuthService.getUserCredentials();
        apicall.getHeaderJson = function() {
            userCredentials = AuthService.getUserCredentials();
            return {
                'Authorization': "apikey " + userCredentials['userid'] + ":" + userCredentials['api_key'],
                'x-api-key': 'uHr2kplt4d4YYs4DrZxTmav558YAjk2V1Vdw5HPn',
                'Content-Type': 'application/json'
            }
        };
        apicall.getParameters = function() {
            userCredentials = AuthService.getUserCredentials();
            return {
                'platform': userCredentials['userplatform'],
                'device': userCredentials['device_model']
            }
        };
        apicall.getHeaderAccesskey = function() {
            userCredentials = AuthService.getUserCredentials();
            return {
                'Authorization': userCredentials['api_key'],
                'x-api-key': 'uHr2kplt4d4YYs4DrZxTmav558YAjk2V1Vdw5HPn',
                'Content-Type': 'application/json'
            }
        };
        apicall.forgotPasswordHeader = function() {
            userCredentials = AuthService.getUserCredentials();
            return {
                'Content-Type': 'application/json',
                'x-api-key': 'uHr2kplt4d4YYs4DrZxTmav558YAjk2V1Vdw5HPn'
            }
        };
        return apicall;
    })
    .factory('Loader', function($ionicLoading) {
        var loader = {};
        loader.show = function() {
            $ionicLoading.show({
                template: '<div style="position: fixed;top: 50%; left: 50%;transform: translate(-50%, -50%);"><ion-spinner icon="ripple"></ion-spinner></div>'
            });
        };
        loader.hide = function() {
            $ionicLoading.hide();
        };
        return loader;
    })
    .factory('AmazonUrls', function($ionicLoading) {

        function uuidv4() 
        {
            return 'xxxxxxxx-xxxx-4xxx-yxxx-xxxxxxxxxxxx'.replace(/[xy]/g, function(c) 
                { 
                    var r = Math.random() * 16 | 0, v = c == 'x' ? r : (r & 0x3 | 0x8); 
                    return v.toString(16); 
                }
            ); 
        }
        var url = {};
        urlList = {
            'mobilesignin': 'https://kpi.knowlarity.com/demo/v1/account/mobilesignin',
            'agentlist': 'https://kpi.knowlarity.com/demo/v1/account/mobile-agent',
            'agentstatus' : 'https://kpi.knowlarity.com/Basic/v1/account/agent/',
            'statuslist' : 'https://kpi.knowlarity.com/Basic/v1/account/agent/status-list/',
            'breaklist' : 'https://kpi.knowlarity.com/Basic/v1/account/agent/custom-break/',
            'changestatus' : 'https://kpi.knowlarity.com/Basic/v1/account/agent/',
            'clicktocall': 'https://kpi.knowlarity.com/demo/v1/account/call/click2call',
            'calllog': 'https://kpi.knowlarity.com/demo/v1/account/mobile-calllogs',
            'tasklist': 'https://kpi.knowlarity.com/demo/v1/account/tasks',
            'coinbalance': 'https://kpi.knowlarity.com/demo/v1/account/coin-balance',
            'dailyaggregation': 'https://kpi.knowlarity.com/demo/v1/account/dailyaggregation',
            'daily_call_location': 'https://kpi.knowlarity.com/demo/v1/account/daily-call-location',
            'contactlist': 'https://kpi.knowlarity.com/demo/v1/account/customer/',
            'profilepic': 'https://sr.knowlarity.com/newsr/mobilephotodownload',
            'forgotpassword': 'https://kpi.knowlarity.com/demo/v1/account/forgot-password/',
            'account': 'https://kpi.knowlarity.com/demo/v1/account/settings/',
            'subscribeNotifications': 'https://kpi.knowlarity.com/demo/v1/account/subscribenotifications/',
            'unSubscribeNotifications': 'https://kpi.knowlarity.com/demo/v1/account/unsubscribenotifications/',
            'webCallListFetching': 'https://rkkl1h8val.execute-api.ap-south-1.amazonaws.com/stage/api/chrome-plugin/',
            'markingWebCallRead' : 'https://rkkl1h8val.execute-api.ap-south-1.amazonaws.com/stage/api/chrome-plugin/' ,
            'telcoCircle':'http://etsrds.kapps.in/webapi/api/get_callercircle.py',
            'callerid':'https://kpi.knowlarity.com/demo/v1/account/caller-id/',
            'resetpassword': 'https://kpi.knowlarity.com/demo/v1/account/reset_password/',
            'checkAppUpdate' : 'https://s3.ap-south-1.amazonaws.com/kite-bucket-prod/mobile_app/version.json?randomVersion='+uuidv4(),
            'mobileAnalytics' : 'https://aktgo5g1ti.execute-api.ap-south-1.amazonaws.com/prod/kcdr_mobile_collect_data',
            'registerUser' : 'https://sr.knowlarity.com/vr/api/registerUser/',
            'createSRAccount' : 'https://www.knowlarity.com/api/createSRAccount.php',
            'termsandcondition' : 'https://sr.knowlarity.com/newsr/api/v1/user/agreement_content_user/'            
        };
        url.getUrl = function(url) {
            return urlList[url];
        }
        return url;
    });