angular.module('starter.filter', [])
    //filter to convert time to displayformat
    .filter('formatDate', function() {
        return function(value) {
            if (!value) return '';
            value = value.replace(' ', 'T');
            var monthNames = ["Jan", "Feb", "Mar", "Apr", "May", "Jun",
                "Jul", "Aug", "Sep", "Oct", "Nov", "Dec"
            ];
            var date = new Date(value).getDate();
            var month = new Date(value).getMonth();
            var year = ('0' + new Date(value).getYear()).slice(-2);
            var finaldate = "" + date + " " + monthNames[month] + " " + year;
            return finaldate;
        }
    })
    .filter('formatTime', function() {
        return function(value) {
            if (!value) return '';
            return (new Date(value.replace(/-/g, '/').replace('T', ' ')));
        }
    })
    .filter('formatTimecall', function() {
        return function(value) {
            if (!value) return '';
            return value.split("+")[0].split(/ +/)[1]
        }
    })
    // send today or yesterday
    .filter('day', function() {
        return function(value) {
            var today = moment();
            var yesterday = moment().subtract(1, 'day');
            var hoursMinutes = " " + ('0' + new Date(value.replace(/-/g, '/').replace('T', ' ')).getHours()).slice(-2) + ":" + ('0' + new Date(value.replace(/-/g, '/').replace('T', ' ')).getMinutes()).slice(-2);
            if (moment(value).isSame(today, 'day'))
                return 'Today' + hoursMinutes;
            else if (moment(value).isSame(yesterday, 'day'))
                return 'Yesterday' + hoursMinutes;
            else
                return moment(value).format('DD MMM YYYY, HH:mm');

        }
    })
    .filter('balanceImage', function() {
        return function(value) {
            if (!value) return '';
            if (value < 50 ? value = 'build/low.png' : value < 75 ? value = 'build/mid.png' : value = 'build/high.png');
            return value;
        }
    })
    .filter('capitalize', function() {
        return function(input, all) {
            var reg = (all) ? /([^\W_]+[^\s-]*) */g : /([^\W_]+[^\s-]*)/;
            return (!!input) ? input.replace(reg, function(txt) {
                return txt.charAt(0).toUpperCase() + txt.substr(1).toLowerCase();
            }) : '';
        }
    })
    .filter('ellipsis', function() {
        return function(value, max) {
            if (!value) return '';
            max = parseInt(max, 10);
            if (!max) return value;
            if (value.length <= max) return value;
            else return value.substr(0, max - 1) + "..."
        }
    })
    .filter('newextractNote', function() {
        return function(value, max) {
            result = value.split(' ').slice(4).join(' ');
            return result;

        }
    })
    .filter('newextractTime', function() {
        return function(value, max) {
            var temp = value.split(' ');
            result = temp.slice(0, 4).join(' ');
            return result;

        }
    })
    .filter('sound_length', function() {
        return function(duration) {
            var sec_num = parseInt(duration, 10); // don't forget the second param
            var hours = Math.floor(sec_num / 3600);
            var minutes = Math.floor((sec_num - (hours * 3600)) / 60) + (hours * 60);
            var seconds = sec_num - (hours * 3600) - (minutes * 60);
            if (minutes < 10) { minutes = "0" + minutes; }
            if (seconds < 10) { seconds = "0" + seconds; }
            return minutes + ':' + seconds;
        }
    })
    .filter('unknown', function() {
        return function(value) {

            if (!value) return 'Unknown';
            return value;
        }
    })
    .filter('formatDate_note', function() {
        return function(value) {
            var monthNames = ["Jan", "Feb", "Mar", "Apr", "May", "Jun",
                "Jul", "Aug", "Sep", "Oct", "Nov", "Dec"
            ];
            var date = new Date().getDate();
            var month = new Date().getMonth();
            var time = new Date().getHours() + ':' + new Date().getMinutes();
            var finaldate = "" + date + " " + monthNames[month] + " " + time;
            return finaldate;
        }
    })

    .filter('number_from_destination', function() {
        return function(value) {
            var n = value.search(/\+/g);
            return n == -1 ? "Unknown" : value.substring(n);
        }
    });
