angular.module('starter.services', ['ngCordova.plugins.contacts'])
.service('AuthService', function($q, $rootScope, $http, AmazonUrls, JsonToFormdata, GetAgents, Loader, CustomerProfilePic, $window, $cordovaDevice, $injector) {
         /*
         Allow Console will expose(Display) all the errors and information in console
         To make it easy to debug and understand the background process.

         Note: Keet it true only while debugging, make it false while in production. 
        */
        $rootScope.allowConsole = false
        var self = this,
            nativeStorage,
            notification;
        this.userCredentials = null;
        this.authCredentials = null;
        this.authenticated = false;
        this.statusList = null;
        this.breakList = null;
        // $rootScope.isAuthenticated = false;
        this.isAuthenticated = function() {
            if (self.authenticated || self.getUserCredentials()){
                return true;
            }
            return false;
        }
        this.setUserCredentials = function(data) {
            $window.localStorage.setItem("userCredentials", JSON.stringify(data));
            self.userCredentials = data;
            self.authenticated = true;
        }
        this.getUserCredentials = function() {
            return self.userCredentials = self.userCredentials || JSON.parse($window.localStorage.getItem("userCredentials"))
        }
        this.getUserCredentialsWithPromise = function() {
            var deferred = $q.defer();
            deferred.resolve(self.userCredentials = self.userCredentials || JSON.parse($window.localStorage.getItem("userCredentials")));
            return deferred.promise;
        }
        this.unSetUserCredentials = function() {
            $window.localStorage.removeItem("userCredentials");
            self.userCredentials = null;
            self.authenticated = false;
        }
        this.setAuthCredentials = function(credentials) {
            $window.localStorage.setItem("authCredentials", JSON.stringify(credentials));
            self.authCredentials = credentials;
        }
        this.getAuthCredentials = function() {
            return self.authCredentials = self.authCredentials || JSON.parse($window.localStorage.getItem("authCredentials"));
        }
        this.unSetAuthCredentials = function() {
            $window.localStorage.removeItem("authCredentials");
            self.authCredentials = null;

            nativeStorage.removeKeys();
        }
        this.getAgentname = function(agentPhone) {
            var temp = JSON.parse($window.localStorage.getItem("agents"));
            for (var i = 0; i < temp.length; i++) {
                if (agentPhone.indexOf(temp[i].country_code) != -1) {
                    if (agentPhone.indexOf(temp[i].phone) != -1) {
                        return temp[i].first_name;
                    }
                }
            }
        }
        this.getRandomUUID =function(){
            function s4() {
                return Math.floor((1 + Math.random()) * 0x10000)
                .toString(16)
                .substring(1);
                }
                 return s4() + s4() + '-' + s4() + '-' + s4() + '-' +
                    s4() + '-' + s4() + s4() + s4();
        }
        this.getCurrentDate = function(){
            var dateObj = new Date();
            var curr_date = dateObj.getDate();
            var curr_month = dateObj.getMonth();
            curr_month = curr_month + 1;
            var curr_year = dateObj.getFullYear();
            var curr_min = dateObj.getMinutes();
            var curr_hr= dateObj.getHours();
            var curr_sc= dateObj.getSeconds();
            if(curr_month.toString().length == 1)
             curr_month = '0' + curr_month;
            if(curr_date.toString().length == 1)
              curr_date = '0' + curr_date;
            if(curr_hr.toString().length == 1)
              curr_hr = '0' + curr_hr;
             if(curr_min.toString().length == 1)
              curr_min = '0' + curr_min;
            if(curr_sc.toString().length == 1)
            curr_sc = '0' + curr_sc;
            var mydate = curr_year+'-'+curr_month+'-'+curr_date+' '+curr_hr+':'+curr_min+':'+curr_sc;
            return mydate;
        }
        this.createEventPacket = function(category, label, action, value, misc, eventBatch){
            var eventId = self.getRandomUUID();
            var date = self.getCurrentDate();
            var user_id = self.getUserCredentials()['user_id'];
            var android_ver = '';
            var app_ver = $rootScope.appVersion;
            var model = '';
            if ((ionic.Platform.isAndroid() || ionic.Platform.isIOS()) && window.cordova) {
                android_ver = $cordovaDevice.getVersion();
                model = $cordovaDevice.getModel();
            }
            var eventData = {event_id : eventId, sr_user_id: user_id, category : category,
             android_version : android_ver, app_version : app_ver, device_model : model, label: label,
             action: action, value: value, device_time : date};
             if(!eventBatch){
                eventBatch = [];
             }
             if(misc){
                eventData.misc = misc;
             }
             eventBatch.push(eventData);
             return eventBatch;
        }
        this.captureEvent = function(eventBatch){
            var deferred = $q.defer();
            var eventUrl = AmazonUrls.getUrl('mobileAnalytics');
            $http.post(eventUrl,{events : eventBatch}, {
                headers: { 'Content-Type': 'application/json' }
             }).success(function(data, status, headers,config){

             if(status == -1){
                 var msg = 'No Network';
                 deferred.resolve(msg);
             }else{
                deferred.resolve(data);
                }
             }).error(function(data, status, header, config) {
                    var msg = 'No Network';
                    deferred.resolve(msg);
             }).finally(function() {
                // Log in console the status
                if($rootScope.allowConsole){
                    console.group("Services.AuthService.captureEvent.Info")
                    console.info("Status:" + status)
                    console.group("Services.AuthService.captureEvent.Info")
                }
             });
            return deferred.promise;

            // Log in console the status
            if($rootScope.allowConsole){
                console.group("Services.AuthService.captureEvent.Info")
                console.info("Status:" + status)
                console.group("Services.AuthService.captureEvent.Info")
            }
        }

        this.login = function(credentials) {
            var deferred = $q.defer();
            if (!nativeStorage) { nativeStorage = $injector.get('nativeStorage'); }
            if (!notification) { notification = $injector.get('notification'); }
            if (credentials.username.indexOf(' ') >= 0)
            {
                var msg = "Your user name has a space in it. Login using your email id in username field.";
                deferred.reject(msg);
            }
            var url = AmazonUrls.getUrl('mobilesignin') + '?password=' + encodeURIComponent(credentials.password) + '&username=' + encodeURIComponent(credentials.username);
            if ((ionic.Platform.isAndroid() || ionic.Platform.isIOS()) && window.cordova) {
                platform_login = ionic.Platform.platform();
                device_login = $cordovaDevice.getModel();
            } else {
                platform_login = 'Mobile';
                device_login = 'Browser';
            }
            $http.get(url, {
                    headers: { 'x-api-key': 'uHr2kplt4d4YYs4DrZxTmav558YAjk2V1Vdw5HPn' },
                    params: { 'platform': platform_login, 'device': device_login }
                })
                .success(function(data, status, headers, config) {
                    if(data){
                        deferred.resolve(data);
                        data.userid = credentials['username'];
                        data.userplatform = platform_login;
                        data.device_model = device_login;
                        self.setUserCredentials(data);
                        self.setAuthCredentials(credentials);
                        self.getStatusList();
                        self.getCustBreakList();
                        nativeStorage.sync();
                        // notification.register();
                    }
                    else
                    {
                        var msg = "No Network";
                        deferred.reject(msg);
                    }
                })
                .error(function(data, status, header, config) {
                    var msg = status == -1 ? "No Network" : "Please enter valid username/password";
                    deferred.reject(msg);
                }).finally(function() {});
            return deferred.promise;
        };
        this.setStList = function(data) {
            $window.localStorage.setItem("statuslist", JSON.stringify(data));
            self.statusList = data;
        }
        this.getStList = function() {
            return self.statusList = self.statusList || JSON.parse($window.localStorage.getItem("statuslist"))
        }
        this.setBreakList = function(data) {
            $window.localStorage.setItem("breaklist", JSON.stringify(data));
            self.breakList = data;
        }
        this.getBreakList = function() {
            return self.breakList = self.breakList || JSON.parse($window.localStorage.getItem("breaklist"))
        }
        this.getStatusList = function(){
            var deferred = $q.defer();
            var userCredentials = self.getUserCredentials();
            var url = AmazonUrls.getUrl('statuslist');
            $http.get(url, {
                    headers: {
                                'Authorization': "apikey " + userCredentials['userid'] + ":" + userCredentials['api_key'],
                                'x-api-key': 'uHr2kplt4d4YYs4DrZxTmav558YAjk2V1Vdw5HPn',
                                'Content-Type': 'application/json'
                             }
                })
                .success(function(data, status, headers, config) {
                    if ($rootScope.internet == 1) {
                        self.setStList(data);
                        return deferred.resolve(data);
                    }
                    else{
                        return deferred.reject(data);
                    }
                })
                .error(function(data, status, header, config) {
                    if(data.error != null && data.error.message != null){
                        $ionicPopup.alert({
                            title: 'Error !',
                            template: data.error.message
                        });
                    }
                    else
                    {
                        console.log("no status list.")
                    }
                    return deferred.reject(status);
            });
            return deferred.promise;
        }

        this.getCustBreakList = function(){
            var deferred = $q.defer();
            var userCredentials = self.getUserCredentials();
            var url = AmazonUrls.getUrl('breaklist');
            $http.get(url, {
                    headers: {
                        'Authorization': "apikey " + userCredentials['userid'] + ":" + userCredentials['api_key'],
                        'x-api-key': 'uHr2kplt4d4YYs4DrZxTmav558YAjk2V1Vdw5HPn'
                    },
                    params: {'user_id': userCredentials['user_id']}
                })
                .success(function(data, status, headers, config) {
                    if ($rootScope.internet == 1 && typeof data !== "undefined") {
                        self.setBreakList(data);
                        console.log(JSON.stringify(data));
                        return deferred.resolve(data);
                    }
                    else{
                        return deferred.reject(data);
                    }
                })
                .error(function(data, status, header, config) {
                    if (typeof data === "undefined") {
                        console.log("no break list.");
                        self.setBreakList(null);
                    }
                    else if(data.error != null && data.error.message != null){
                        $ionicPopup.alert({
                            title: 'Error !',
                            template: data.error.message
                        });
                    }
                    else
                    {
                        console.log("no break list.")
                    }
                    return deferred.reject(status);
            });
            return deferred.promise;
        }

        this.changeStatus = function(agentstatus){
            var deferred = $q.defer();
            var userCredentials = self.getUserCredentials();
            var userId = userCredentials['userid'];
            var api = userCredentials['api_key'];
            var phone = userCredentials['contact_number'];
            var url = AmazonUrls.getUrl('changestatus');
            var bodyString = JSON.stringify({status: agentstatus});
            if (JSON.stringify(agentstatus).indexOf("On Break") > 0 && self.getBreakList() != null)
                bodyString = JSON.stringify({status: agentstatus.split(":")[0].trim(), custom_type: agentstatus.split(":")[1].trim()});
            $http.put(url,  bodyString, {
                        headers: { 'Authorization': api,
                           'x-api-key': 'uHr2kplt4d4YYs4DrZxTmav558YAjk2V1Vdw5HPn',
                           'Content-Type': 'application/json',
                           'agent_number': phone
                    }
                })
                .success(function(data, status, headers, config) {
                    if ($rootScope.internet == 1) {
                        return deferred.resolve(data);
                    }
                    else{
                        return deferred.reject(data);
                    }
                })
                .error(function(data, status, header, config) {
                    if(data.error != null && data.error.message != null){
                        $ionicPopup.alert({
                            title: 'Error !',
                            template: data.error.message
                        });
                    }
                    else
                    {
                        console.log("no status change")
                    }
                    return deferred.reject(status);
            });
            return deferred.promise;
        }
    })
    .service('getTelcoCircle', function($q, $http, AmazonUrls, $window, $cordovaDevice) {
        this.get_telco_circle = function(number) {
            var deferred = $q.defer();
            var url = AmazonUrls.getUrl('telcoCircle');
            $http.get(url, {
                params: {'caller_number': number}
            })
            .success(function(data) {
                parser = new DOMParser();
                xmlDoc = parser.parseFromString(data,"text/xml");
                caller_circle = xmlDoc.getElementsByTagName('root')[0].children[0].innerHTML;
                console.log(String(caller_circle))
                deferred.resolve(caller_circle);
            })
            .error(function(data, status, headers, config) {
                deferred.reject(msg);
            });
            return deferred.promise;
        }

    })
    .service('CreateSRAccount', function(ApiCall, $q, $http, AmazonUrls, $window, $cordovaDevice, Loader) {
        this.registerUser = function(phone_number, email, name, city_id, password, country_code, country) {
            var number_type = 'default';
            if (country_code == '%2B63' || country_code == '%2B66' || country_code == '%2B971')
                number_type = 'demo';
            else
                number_type = 'default';

            Loader.show();
            var deferred = $q.defer();
            var url = AmazonUrls.getUrl('registerUser');
            var params= {'phone_number' : phone_number,
                    'email' : email,
                    'name' : name,
                    'plan_name' : 'Advance',
                    'city_id' : city_id,
                    'password' : password,
                    'plan_validity' : '31',
                    'mandrill_template' : 'first_time_user_signup-newflow-v1',
                    'number_type' : number_type,
                    'country_code' : country_code,
                    'kyc_enabled' : '1',
                    'country' : country };
            console.log(params);
            $http({
                    method: 'POST',
                    url: url,
                    headers: ApiCall.forgotPasswordHeader(),
                    params: params
            })
            .success(function(data) {
                deferred.resolve({
                    response: data
                });
            })
            .error(function(msg, code) {
                deferred.reject(msg);
            }).finally(function() {
                Loader.hide();
            });
            return deferred.promise;
        }

        this.createSRAcc = function(email, phone_number,  username) {
            var phone = "";
            if (phone_number.indexOf('+') >= 0)
                phone = phone_number.replace("+","%2B");
            Loader.show();
            var deferred = $q.defer();
            var url = AmazonUrls.getUrl('createSRAccount');
            var params= {'username' : username,
                    'email' : email,
                    'phone_number' : phone};
            $http({
                method: 'POST',
                url: url,
                headers: ApiCall.forgotPasswordHeader(),
                data: JSON.stringify(params)
            })
            .success(function(data) {
                deferred.resolve({
                    response: data
                });
            })
            .error(function(msg, code) {
                deferred.reject(msg);
            }).finally(function() {
                Loader.hide();
            });
            return deferred.promise;
        }

    })
    .service('GetAgents', function($rootScope, $q, $http, AmazonUrls, $window, $cordovaDevice) {
        var self = this;
        this.agents = function(userCredentials) {
            var deferredIn = $q.defer();
            //Default value
            //Will be replaced by the actual value
            $rootScope.totalAgentcount = 0
            //offset
            var offset = 150
            //offset increment
            var offsetIncrement = 150
            /*
                Steps in fetching agents
                1. Find total agents count
                2. Loop the API request in patched of size assigned by
                   offsetIncrement
                3. After first fetching, continue the process, while the
                   loop will continue in fetching the agents data
            */
            //To Clean the local storage
            $window.localStorage.setItem('agents', null);
            console.log(JSON.stringify(userCredentials));
            //Step 1
            //getting the total agents count
            $rootScope.callAgentsApi("meta",  userCredentials, 0 , offset,$q.defer()).then(function(){
                if($rootScope.allowConsole){
                    console.log("Total Agents: " + $rootScope.totalAgentcount)
                }

                //Step 2
                //Run loop while total count is not matched by offset
                //After first fetching, deferred value will be sent
                //To continue the process of login
                if(offset < $rootScope.totalAgentcount){
                    while(offset < $rootScope.totalAgentcount){
                        if($rootScope.allowConsole){
                             console.log("Fetching Agents from: " + offset + " -> " + (offset + offsetIncrement) )
                        }
                        //Fetching the Agents Data
                        $rootScope.callAgentsApi("agents", userCredentials, offset, offsetIncrement, deferredIn)
                        //Increase the value of offset
                        offset += offsetIncrement
                    }
                }else
                //To complete the promise
                deferredIn.resolve();
            })
            return deferredIn.promise;
        }

        this.getAgents = function() {

            if($rootScope.allowConsole){
                console.group("Services.GetAgents.getAgents.Info")
                console.table(JSON.parse($window.localStorage.getItem("agents")))
                console.groupEnd("Services.GetAgents.getAgents.Info")
              }

            return $window.localStorage.getItem("agents") != 'undefined' ? JSON.parse($window.localStorage.getItem("agents")) : "";
        }
        /*
            Function to hit the API to fetch requered agents data

            #requestType: What information is required
                meta: to request meta data
                agents: to request agents list and information

        */
        $rootScope.callAgentsApi = function(requestType ,userCredentials, offset, offsetIncrement, deferred){
            var url = AmazonUrls.getUrl('agentlist');
            var userId = userCredentials['userid'];
            var api = userCredentials['api_key'];
            //Comman variable for all the return back values
            var sendBack = null

            $http.get(url, {
                headers:{ 'Authorization': "apikey " + userId + ":" + api },
                params: {
                          'platform': $rootScope.getPlatformInfo()[0],
                          'device': $rootScope.getPlatformInfo()[1] ,
                          'limit': offsetIncrement,
                          'offset': offset
                        }
            })
            .success(function(data, status, headers, config) {
                //InCase user is looking for meta data
                //Here default value of offset and offsetIncrement will be used
                //which is 0 and 1 respectively, to make the process quick
                if(requestType == "meta"){
                    sendBack = data["meta"]
                    $rootScope.totalAgentcount = sendBack ? sendBack.total_count : ""
                    $window.localStorage.setItem('agents', JSON.stringify(data['objects']))
                    if($rootScope.allowConsole){
                        console.group("Services.GetAgents.Meta.Success." + offset)
                        console.info("First Information added")
                        console.info("Fetching Agents from: " + + offset + " -> " + (offset + offsetIncrement))
                        console.groupEnd("Services.GetAgents.Meta.Success." + offset)
                    }
                }
                //InCase user is looking agents information and list
                else if(requestType == "agents"){
                    sendBack = data['objects']
                    //Here we will store the fetched information in localStorage
                    //If localStorage object is empty/null
                    //it can't be merged with the new information

                    //Checking if localStorage is not empty
                    if(JSON.parse($window.localStorage.getItem("agents")) != null){
                        //We will use concat() to merge the old storage value to new value
                        $window.localStorage.setItem('agents', JSON.stringify(JSON.parse($window.localStorage.getItem("agents")).concat(sendBack)))
                        if($rootScope.allowConsole){
                            console.group("Services.GetAgents.callAgentsApi.Success." + offset)
                            console.info("Previous agents data merged in localStorage")
                            console.groupEnd("Services.GetAgents.callAgentsApi.Success." + offset)
                        }
                    }else{
                        $window.localStorage.setItem('agents', JSON.stringify(sendBack))
                        if($rootScope.allowConsole){
                            console.group("Services.GetAgents.callAgentsApi.Success." + offset)
                            console.info("No agents data in localStorage")
                            console.groupEnd("Services.GetAgents.callAgentsApi.Success." + offset)
                        }
                    }
                }
                deferred.resolve(sendBack);
            })
            .error(function(data, status, header, config) {
                if($rootScope.allowConsole){
                    console.group("Services.GetAgents.callAgentsApi.Error." + offset)
                    console.error("Status: " + status)
                    console.groupEnd("Services.GetAgents.callAgentsApi.Error." + offset)
                }
                deferred.reject(status);
            });

            //Since this information is same in all cases
            //hence, it will be printed just once for meta
            if(requestType == "meta"){
                if($rootScope.allowConsole){
                    console.group("Services.GetAgents.callAgentsApi.Info")
                    console.info("Platform: " + platform_login)
                    console.info("Device: " + device_login)
                    console.info("url: " + url)
                    console.info("userId: " + userId)
                    console.info("api: " + api)
                    console.info("process: " + "apikey " + userId + ":" + api)
                    console.groupEnd("Services.GetAgents.callAgentsApi.Info")
                }
            }

            return deferred.promise;
        }
        /*
            Function to return the platform information

            #Return Type: Array
                array(0) = platform_login
                array(1) = device_login
        */
        $rootScope.getPlatformInfo = function(){
            if ((ionic.Platform.isAndroid() || ionic.Platform.isIOS()) && window.cordova) {
                platform_login = ionic.Platform.platform();
                device_login = $cordovaDevice.getModel();
            } else {
                platform_login = 'Mobile';
                device_login = 'Browser';
            }

            return [platform_login, device_login]
        }

        /*
            Function to return the agent current status
            #Return Type: Array
                array(0) = agent data
        */
        this.getAgentStatus = function(userCredentials) {
            var deferred = $q.defer();
            var url = AmazonUrls.getUrl('agentstatus');
            var userId = userCredentials['userid'];
            var api = userCredentials['api_key'];
            var phone = userCredentials['contact_number'];
            //Comman variable for all the return back values
            var sendBack = null

            $http.get(url, {
                headers: { 'Authorization': "apikey " + userId + ":" + api,
                           'x-api-key': 'uHr2kplt4d4YYs4DrZxTmav558YAjk2V1Vdw5HPn',
                           'Content-Type': 'application/json',
                           'agent_number': phone
                         },
                params: {
                          'phone': phone
                        }
            })
            .success(function(data, status, headers, config) {
                //InCase user is looking agentstatus information and list
                    sendBack = data['objects']
                    $window.localStorage.setItem('agentstatus', JSON.stringify(sendBack[0]['status']))
                    if($rootScope.allowConsole){
                        console.group("Services.GetAgents.getAgentStatus.Success.")
                        console.info("No agentstatus data in localStorage")
                        console.groupEnd("Services.GetAgents.getAgentStatus.Success.")
                    }

                return deferred.resolve(sendBack[0]['status']);
            })
            .error(function(data, status, header, config) {
                if($rootScope.allowConsole){
                    console.group("Services.GetAgents.getAgentStatus.Error.")
                    console.error("Status: " + status)
                    console.groupEnd("Services.GetAgents.getAgentStatus.Error.")
                }
                return deferred.reject("");
            });

            return deferred.promise;
        }

        this.getStatus = function(userCredentials) {
            // if($rootScope.allowConsole){
            //     console.group("Services.GetAgents.getStatus.Info")
            //     console.table(JSON.parse($window.localStorage.getItem("agentstatus")))
            //     console.groupEnd("Services.GetAgents.getStatus.Info")
            //   }
            if(JSON.parse($window.localStorage.getItem("agentstatus")) != null) {
                return JSON.parse($window.localStorage.getItem("agentstatus"));
            } else {
                return null;
            }
        }

        this.unSetAgentStatus = function() {
            $window.localStorage.removeItem("agentstatus");
        }
    })

    .service('ClickToCall', function($q, $http, AuthService, $ionicPopup, ApiCall, ionicToast, AmazonUrls, CreditsService, $rootScope) {
        this.click = function(customerNumber) {

            ionicToast.show("Click to call initiated", 'middle', false, 1000);
            var userCredentials = AuthService.getUserCredentials();
            var srUse = userCredentials.sr_number;
            if (srUse.indexOf(',') != -1)
                srUse = srUse.split(',')[0];
            var number = encodeURIComponent(srUse);
            var agent = encodeURIComponent(userCredentials['contact_number']);
            var customer = encodeURIComponent(customerNumber);
            var url = AmazonUrls.getUrl('clicktocall') + "?sr_number=" + number + "&agent_number=" + agent + "&phone_number=" + customer;
            $http.get(url, {
                    headers: ApiCall.getHeaderJson(),
                    params: ApiCall.getParameters()
                })
                .success(function(data, status, headers, config) {
                    if ($rootScope.internet == 1) {
                        $ionicPopup.alert({
                            title: 'SUCCESS !',
                            template: 'Your call will be connected shortly'
                        });
                    }
                })
                .error(function(data, status, header, config) {
                    $ionicPopup.alert({
                        title: 'Error !',
                        template: data.error.message
                    });
            });
        }

        this.c2cClick_country_code = function(srnumber,customerCountryCode, customerNumber,agentCountryCode,agentNumber,callerIdNum){
            /**
            *This function check if the entered number by the user is blank then
            *it returns the error else it will call c2cClick function
            **/

            if(customerNumber == null || customerNumber == '')
            {
                $ionicPopup.alert({
                            title: 'INVALID !',
                            template: 'Please enter a valid number'
                        });
            }
            else
            {
                customerNumber = customerNumber.replace(/^0+/, '');
                if(callerIdNum !=null && callerIdNum != '' && callerIdNum != 'None'){
                    this.c2cClick(srnumber,customerCountryCode+customerNumber,
                                    agentCountryCode+agentNumber,callerIdNum);
                }
                else{
                    this.c2cClick(srnumber,customerCountryCode+customerNumber,
                                    agentCountryCode+agentNumber);
                }
            }
        }

        this.c2cClick = function(srnumber, customerNumber, agentNumber, callerIdNum) {
            srnumber = srnumber + '';
            ionicToast.show("Click to call initiated", 'middle', false, 1000);
            var userCredentials = AuthService.getUserCredentials();
            var agent = agentNumber && encodeURIComponent(agentNumber) || encodeURIComponent(userCredentials['contact_number']);
            var customer = encodeURIComponent(customerNumber);
            var srnumber = encodeURIComponent(srnumber);
            var url = AmazonUrls.getUrl('clicktocall') + "?sr_number=" + srnumber + "&agent_number=" + agent + "&phone_number=" + customer;
            if(typeof callerIdNum !== "undefined"){
                url = url +"&caller_id="+encodeURIComponent(callerIdNum);
            }
            $http.get(url, {
                    headers: ApiCall.getHeaderJson(),
                    params: ApiCall.getParameters()
                })
                .success(function(data, status, headers, config) {
                    $ionicPopup.alert({
                        title: 'SUCCESS !',
                        template: 'Your call will be connected shortly'
                    });
                }).error(function(data, status, header, config) {
                    $ionicPopup.alert({
                        title: 'Error !',
                        template: data.error.message
                    });
                });
        }

        this.getCallerId = function(srnumber){
            var deferred = $q.defer();
            var userCredentials = AuthService.getUserCredentials();
            var url = AmazonUrls.getUrl('callerid') + "?sr_number=" + encodeURIComponent(srnumber);
            $http.get(url, {
                    headers: ApiCall.getHeaderJson(),
                    params: ApiCall.getParameters()
                })
                .success(function(data, status, headers, config) {
                    if ($rootScope.internet == 1) {
                        return deferred.resolve(data);
                    }
                    else{
                        return deferred.reject(data);
                    }
                })
                .error(function(data, status, header, config) {
                    if(data.error != null && data.error.message != null){
                        $ionicPopup.alert({
                            title: 'Error !',
                            template: data.error.message
                        });
                    }
                    else
                    {
                        console.log("no cli no.")
                    }
                    return deferred.reject(status);
            });
            return deferred.promise;
        }
    })
    .service('CallLogService', function($q, $http, ApiCall, AmazonUrls, $log, Loader, AuthService) {
        var self = this;
        this.s3MobileCallLogHost = "https://s3.ap-south-1.amazonaws.com/sr-mobile-call-sync/";
        this.isMobileCallLog = function(obj) {
            if (obj['user_plan_id'])
                return false
            return true
        }


        this.getCallLog = function(offset, filter, callTypeFilter, start_time, end_time, mobile) {
            var start_time__gt = start_time ? encodeURIComponent(start_time) : encodeURIComponent((moment().subtract(7, 'd').format('YYYY-MM-DDTHH:mm:ss')) + "+5:30");
            var start_time__lt = end_time   ? encodeURIComponent(end_time)   : encodeURIComponent((moment().format("YYYY-MM-DDTHH:mm:ss")) + "+5:30");
            var limit = 50;
            var url = AmazonUrls.getUrl('calllog') + '?limit=' + limit + '&offset=' + offset + '&order_by=-start_time&start_time__gt=' + start_time__gt + '&start_time__lt=' + start_time__lt
                + '&get_total_count=false';
            if (mobile){
                url = url+'&only_mobile_logs=true&get_mobile_call_logs=true';

            } else {
                url = url+'&only_mobile_logs=false&get_mobile_call_logs=false';
            }

            if (filter) {
                if (filter.length >= 13) {
                    url += '&filter__gt=' + encodeURIComponent(filter)}
                else if (filter.length >= 3) {
                    url += '&filter__lt=' + encodeURIComponent(filter)}
            }
            if ((callTypeFilter) && (callTypeFilter != 'All'))
            {
                if (callTypeFilter == "outgoing")
                {
                    url += '&is_outgoing=' + '1';
                }
                else if (callTypeFilter == "incoming")
                {
                    url += '&is_outgoing=' + '0';
                }
                else
                {
                    console.log(callTypeFilter);
                    url += '&ftype__in=' + callTypeFilter;
                }
            }
            return fetchCallLogData(url);
        }
        this.getCallLogWithMobile = function(offset, start_time, end_time) { //pointing to beta
            var userData = AuthService.getUserCredentials();
            var start_time__gt = start_time ? start_time : encodeURIComponent((moment().subtract(90, 'd').format('YYYY-MM-DDTHH:mm:ss')) + "+5:30");
            var start_time__lt = end_time ? end_time : encodeURIComponent((moment().format("YYYY-MM-DDTHH:mm:ss")) + "+5:30");
            var limit = 100;
            var url = 'https://3yclv4ooh1.execute-api.ap-south-1.amazonaws.com/beta/api/kcdr-sr' + '?limit=' + limit + '&offset=' + offset + '&order_by=-start_time&start_time__gt=' + start_time__gt + '&start_time__lt=' + start_time__lt + '&get_mobile_call_logs=true&user_id='+userData['user_id'];
            return fetchCallLogData(url);
        }
        this.getWebCallList = function(offset){//list that comes from crome extension
            var userData = AuthService.getUserCredentials();
            var deferred = $q.defer();
            console.log(AmazonUrls.getUrl('webCallListFetching') + '?user_id=' + userData['user_id']);
            $http({
                    method: 'GET',
                    url: AmazonUrls.getUrl('webCallListFetching'),
                    params: {
                        'user_id': userData['user_id'],
                        'limit' : 100,
                        'offset' : offset
                    },
                    headers: {
                            'Content-Type': 'application/json' ,
                            'Access-Control-Allow-Origin': '*',
                            'Access-Control-Allow-Methods': 'POST, GET, OPTIONS',
                            'Access-Control-Allow-Headers':'X-Requested-With'
                     }
                })
                .success(function(data) {
                    deferred.resolve(data);
                    console.log(JSON.stringify(data));
                })
                .error(function(error) {
                    deferred.reject(error);
                }).finally(function() {});
            return deferred.promise;
        };
        this.markCalled = function(id,start_time,end_time){//list that comes from crome extension
            var deferred = $q.defer();
            console.log(AmazonUrls.getUrl('markingWebCallRead') + '?id=' + id);
            $http({
                    method: 'PATCH',
                    url: AmazonUrls.getUrl('markingWebCallRead'),
                    data: JSON.stringify({
                        "id": id,
                        "status": "read"
                    }),
                    headers: {
                        'Content-Type': 'application/json' ,
                        'Access-Control-Allow-Origin': '*',
                        'Access-Control-Allow-Methods': 'POST, GET, OPTIONS',
                        'Access-Control-Allow-Headers':'X-Requested-With'
                     }
                })
                .success(function(data) {
                    deferred.resolve(data);
                    console.log(JSON.stringify(data));
                })
                .error(function(error) {
                    deferred.reject(error);
                }).finally(function() {});
            return deferred.promise;
        };
        var fetchCallLogData = function(url) {
            var deferred = $q.defer();
            Loader.show();
            $http({
                    method: 'GET',
                    url: url,
                    headers: ApiCall.getHeaderJson(),
                    params: ApiCall.getParameters()
                })
                .success(function(data) {
                    if(data)
                    {
                        self.appendS3HostToMobileSoundFiles(data)
                        deferred.resolve(data);
                    }
                    else
                    {
                        //no network
                        deferred.reject(null);
                    }
                })
                .error(function(error) {
                    deferred.reject(error);
                }).finally(function() {
                    Loader.hide();
                });
            return deferred.promise;
        }
        this.appendS3HostToMobileSoundFiles = function(data){
            data['objects'].forEach(function(element){
                if (self.isMobileCallLog(element) && element['ftype']!='Missed Call' && element['filepath'])
                    element['filepath'] = self.s3MobileCallLogHost + element['filepath']
            }, self)
        }
    })
    .service('TodoService', function(ApiCall, $q, $http, AmazonUrls, Loader) {
        this.getTodoData = function(options) {
            Loader.show();
            var deferred = $q.defer();
            var params = ApiCall.getParameters();
            if (options['offset'] != null) {
                params['offset'] = options['offset'];
                params['limit'] = 20;
            }
            if (options['is_completed'] != null){
                if (options['is_completed'] == true) {
                    params['is_completed'] = true;}
                else if (options['is_completed'] == false){
                    params['is_completed'] = false;}
            }
            if (options['phone__in'] != null) {
                params['phone__in'] = options['phone__in'];}
            if (options['phone__startswith'] != null){
                params['phone__startswith'] = options['phone__startswith'];}
            $http({
                    method: 'GET',
                    url: AmazonUrls.getUrl('tasklist'),
                    headers: ApiCall.getHeaderJson(),
                    params: params
                })
                .success(function(data) {
                    if(data){
                        deferred.resolve({
                            response: data['objects'],
                            meta: data['meta']
                        });
                    }
                    else{
                        //not connected to internet
                        deferred.reject(null);
                    }
                }).error(function(msg, code) {
                    deferred.reject(msg);
                    // $log.error(msg, code);
                }).finally(function() {
                    Loader.hide();
                });
            return deferred.promise;
        }
    })
    .service('CreditsService', function($http, ApiCall, $q, AmazonUrls, Loader, $log) {
        this.getCredits = function() {
            Loader.show();
            var deferred = $q.defer();
            $http({
                    method: 'GET',
                    url: AmazonUrls.getUrl('coinbalance'),
                    headers: ApiCall.getHeaderJson(),
                    params: ApiCall.getParameters()
                })
                .success(function(data) {
                    deferred.resolve({
                        response: data
                    });
                }).error(function(msg, code) {
                    deferred.reject(msg);
                }).finally(function() {
                    Loader.hide();
                });
            return deferred.promise;
        }
    })
    .service('InsightScreen', function($http, Loader, ApiCall, $q, AmazonUrls) {
        this.insightscreen = function() {
            Loader.show();
            //var currentdate = (moment().format('YYYY-MM-DD'));
            //var previousdate = moment().subtract(7, 'days').format('YYYY-MM-DD');
            var calldata_totalsum = missed_calls = phone = no_input = DTMF = sound = call_group = DNP = Voicemail = 0;
            var incoming = outgoing = 0;
            var deferred = $q.defer();

            // var start_time__gt = encodeURIComponent((moment().subtract(1, 'd').format('YYYY-MM-DDTHH:mm:ss')) + "+5:30");
            var start_time__gt = encodeURIComponent((moment().startOf('day').format('YYYY-MM-DDTHH:mm:ss')) + "+5:30");
            var start_time__lt = encodeURIComponent((moment().format("YYYY-MM-DDTHH:mm:ss")) + "+5:30");
            var limit = 100;
            var url = AmazonUrls.getUrl('calllog') + '?limit=' + limit + '&offset=' + 0 + '&order_by=-start_time&start_time__gt=' + start_time__gt + '&start_time__lt=' + start_time__lt+'&get_mobile_call_logs=true';

            $http({
                    method: 'GET',
                    //url: AmazonUrls.getUrl('dailyaggregation') + '?date__gte=' + previousdate + '&date__lte=' + currentdate,
                    url: url,
                    headers: ApiCall.getHeaderJson(),
                    params: ApiCall.getParameters()
                })
                .success(function(data) {
                    var len = data.meta.total_count;
                    /*for (var i = 0; i < len; i++) {
                        callsum += data.objects[i].new_call;
                        calldata_totalsum += data.objects[i].total_call;
                        missed_calls += data.objects[i].call_missed + data.objects[i].dtmf + data.objects[i].outgoing_missed;
                        answered_calls += data.objects[i].outgoing_call + data.objects[i].call_forwarded;
                    }*/
                    data['objects'].forEach(function(element){
                        calldata_totalsum += 1;
                        incoming = (element['is_outgoing']) ? (incoming+=0) : (incoming+=1);
                        outgoing = (element['is_outgoing']) ? (outgoing+=1) : (outgoing+=0);
                        missed_calls = (element['ftype'] == 'Missed Call') ? (missed_calls+=1) : missed_calls;
                        phone = (element['ftype'] == 'Phone') ? (phone+=1) : phone;
                        no_input = (element['ftype'] == 'NO INPUT') ? (no_input+=1) : no_input;
                        DTMF = (element['ftype'] == 'DTMF') ? (DTMF+=1) : DTMF;
                        sound = (element['ftype'] == 'Sound') ? (sound+=1) : sound;
                        call_group = (element['ftype'] == 'Call Group') ? (call_group+=1) : call_group;
                        DNP = (element['ftype'] == 'DNP') ? (DNP+=1) : DNP;
                        Voicemail = (element['ftype'] == 'Voicemail') ? (Voicemail+=1) : Voicemail;
                    }, self)
                    // console.log("Total Call:", len);
                    deferred.resolve({
                        total_count: len,
                        totalcalldata_sum: calldata_totalsum,
                        /*missed_calls: missed_calls,
                        answered_calls: answered_calls*/
                        incoming: incoming,
                        outgoing: outgoing,
                        missed_calls: missed_calls,
                        phone: phone,
                        no_input: no_input,
                        DTMF: DTMF,
                        sound: sound,
                        call_group: call_group,
                        DNP: DNP,
                        Voicemail: Voicemail
                    });
                }).error(function(msg, code) {
                    deferred.reject(msg);
                }).finally(function() {
                    Loader.hide();
                });
            return deferred.promise;
        }
    })
    .service('Geographydata', function(Loader, ApiCall, $http, $q, AmazonUrls) {
        this.getGeographydata = function() {
            Loader.show();
            var currentdate = (moment().format('YYYY-MM-DD'));
            var previousdate = moment().subtract(7, 'days').format('YYYY-MM-DD');
            var deferred = $q.defer();
            $http({
                    method: 'GET',
                    url: AmazonUrls.getUrl('daily_call_location') + '?date__gte=' + previousdate + '&date__lte=' + currentdate,
                    headers: ApiCall.getHeaderJson(),
                    params: ApiCall.getParameters()
                }).success(function(fetch, status, headers, config) {
                    deferred.resolve({
                        fetch: fetch
                    });
                })
                .error(function(fetch, status, header, config) {
                    deferred.reject(msg);
                }).finally(function() {
                    Loader.hide();
                });
            return deferred.promise;
        }
    })
    .service('CustomerData', function(ApiCall, $http, $q, AmazonUrls) {
        this.getCustomerData = function(offset, phonebook__name__istartswith, status) {
            var deferred = $q.defer();
            var url = AmazonUrls.getUrl('contactlist') + '?desktop_site=1&limit=20&offset=' + offset;
            if (phonebook__name__istartswith) {
                  url += '&phonebook__name__istartswith=' + phonebook__name__istartswith;
            }
            if ((status) && (status != 'All')){
                url += '&status=' + status;
            }
            $http({
                    method: 'GET',
                    url: url,
                    headers: ApiCall.getHeaderJson(),
                    params : ApiCall.getParameters()
                })
                .success(function(data) {
                    console.log(data)
                    if(data){
                        var filteredData = data.objects.filter(function(obj) {
                            return obj.phonebook.name != '' || obj.phonebook.phonenumbers_set.length;
                        });
                        data.objects = filteredData
                        deferred.resolve({
                            response: data
                        });
                    }
                    else{
                        //not conected to internet
                        deferred.reject(null);
                    }
                }).error(function(msg, code) {
                    deferred.reject(msg);
                }).finally(function() {});
            return deferred.promise;
        }
    })
    .service('AccountService', function($http, ApiCall, $q, AmazonUrls, Loader, $log, AuthService,nativeStorage) {
        this.getAccountData = function() {
            Loader.show();
            var deferred = $q.defer();
            $http({
                    method: 'GET',
                    url: AmazonUrls.getUrl('account'),
                    headers: ApiCall.getHeaderJson(),
                    params: ApiCall.getParameters()
                })
                .success(function(data) {
                    console.log(data)
                    deferred.resolve({
                        response: data
                    });
                }).error(function(msg, code) {
                    deferred.reject(msg);
                }).finally(function() {
                    Loader.hide();
                });
            return deferred.promise;
        }
        this.saveAccountData = function(account_obj, method) {
            Loader.show();
            var url, deferred = $q.defer();
            if (method == 'POST')
                url = AmazonUrls.getUrl('account')
            else if (method == 'PUT')
                url = AmazonUrls.getUrl('account') + account_obj["resource_uri"].split('/').reverse()[1];
            $http({
                    method: method,
                    url: url,
                    headers: ApiCall.getHeaderJson(),
                    data: JSON.stringify(account_obj),
                    params: ApiCall.getParameters()
                })
                .success(function(data) {
                    deferred.resolve({
                        response: data
                    });
                    if(account_obj.setting_name == "record_sync_mobile_calls_owner"){
                        console.log("value changed through success api");
                        nativeStorage.changeSettings(account_obj.setting_value);
                        console.log("record_sync_mobile_calls : " + account_obj.setting_value);
                        if(window.cordova && ionic.Platform.isAndroid()) {
                            // Stopping Service from Cordova Plugin
                            var eventPlugin = new EventPlugin();
                            if (account_obj.setting_value.indexOf('false') >= 0) {
                                eventPlugin.logout(
                                    'Call listener stopped!',
                                    function(msg) {
                                        console.log(msg);
                                    },
                                    function(err) {
                                        console.log(err);
                                    }
                                );
                            } else {
                                eventPlugin.login(
                                    'Call listener enabled!',
                                    function(msg) {
                                        console.log(msg);
                                    },
                                    function(err) {
                                        console.log(err);
                                    }
                                );
                            }
                        }
                    }
                }).error(function(msg, code) {
                    deferred.reject(msg);
                }).finally(function() {
                    Loader.hide();
                });
            return deferred.promise;
        }
    })
    .service('SaveContact', function(Loader, ApiCall, $http, $q, AmazonUrls, ionicToast, $window) {
        this.savenewContact = function(name, number, company, status, id, followup, existing, follow) {
            Loader.show();
            var deferred = $q.defer();
            if (follow == 'followup')
                customerdata = existing == true ? { "followup_dt": followup, "numbers": [number], "phonebook": { "name": name, "company": company }, "status": status } : { "followup_dt": followup, "numbers": [number], "status": status, "company": company };
            else
                customerdata = existing == true ? { "numbers": [number], "phonebook": { "name": name, "company": company }, "status": status } : { "name": name, "numbers": [number], "status": status, "company": company };
            console.log(customerdata)
            methodcall = existing == true ? 'PUT' : 'POST';
            id = existing == true ? id + '/' : '';
            $http({
                    method: methodcall,
                    url: AmazonUrls.getUrl('contactlist') + id,
                    data: customerdata,
                    headers: ApiCall.getHeaderJson(),
                    params: ApiCall.getParameters()
                })
                .success(function(data) {

                    deferred.resolve({
                        response: data
                    });
                    ionicToast.show(' Contact Updated', 'middle', false, 1000);
                    $window.history.back();
                }).error(function(msg, code) {
                    deferred.reject(msg);
                }).finally(function() {
                    Loader.hide();
                });
            return deferred.promise;
        }
        this.savenewNote = function(note, id, phoneContact,responsedata) {
            //console.log('responseData',responsedata,note)
            Loader.show();
            var deferred = $q.defer();
            var customerdata = responsedata;
            customerdata.note = note;
            //customerdata = responsedata;

            var callMethod = 'PUT';
            //customerdata = existing == true ? { "followup_dt": followup, "numbers": [number], "phonebook": { "name": name, "company": company }, "status": status } : { "followup_dt": followup, "numbers": [number], "status": status, "company": company };

            if (id == '') {
                callMethod = 'POST';
                customerdata = { "note": note, "number": phoneContact, "status": 'Cold' };
            } else
                id = id + '/';

            //console.log('customerdata',customerdata)
           //https://sr.knowlarity.com/newsr/api/v1/customer/29255564/
            $http({
                    method: callMethod,
                    url: AmazonUrls.getUrl('contactlist') + id,
                    data: customerdata,
                    headers: ApiCall.getHeaderJson(),
                    params: ApiCall.getParameters()
                })
                .success(function(data) {

                    ionicToast.show(' Note added', 'middle', false, 1000);
                    deferred.resolve({
                        response: data
                    });
                    //$rootScope.globalnotes = data.notes;
                }).error(function(msg, code) {
                    deferred.reject(msg);
                }).finally(function() {
                    Loader.hide();
                });
            return deferred.promise;
        }
        this.getCallData = function(id) {
            //console.log('came in this function')
            Loader.show();
            var deferred = $q.defer();
            //console.log(AmazonUrls.getUrl('contactlist') + id + '/')
            $http({
                    method: 'GET',
                    url: AmazonUrls.getUrl('contactlist') + id + '/',
                    headers: ApiCall.getHeaderJson(),
                    params: ApiCall.getParameters()
                })
                .success(function(data) {
                    //console.log(data)
                    deferred.resolve({
                        response: data
                    });
                }).error(function(msg, code) {
                    deferred.reject(msg);
                }).finally(function() {
                    Loader.hide();
                });
            return deferred.promise;
        }
    })
    .service('CustomerProfilePic', function($http, AmazonUrls) {
        this.getProfilePic = function() {
            $http({
                    method: 'GET',
                    url: AmazonUrls.getUrl('profilepic'),
                })
                .success(function(data) {
                    if(data == null){
                        //incase of network failure
                        angular.element(document.querySelector('.sr_profile_image')).css('background-image', "url('build/userprofile.png')");
                    }
                    else{
                        var url = 'url(' + data + ')';
                        angular.element(document.querySelector('.sr_profile_image')).css('background-image', url);
                    }
                }).error(function(msg) {
                    angular.element(document.querySelector('.sr_profile_image')).css('background-image', "url('build/userprofile.png')");
                })
        }
    })
    .service('GoogleAnalytics', function() {
        this.screenView = function(screenname) {
            if (typeof gaU !== 'undefined') {
                //analytics.trackView(screenname + " screen");
                gaU('send', 'pageview', screenname);
            }
        }
        this.sendEvent = function(category, action, label) {
            if (typeof gaU !== 'undefined') {
                //analytics.trackEvent(category, action, label, 1);
                gaU('send', 'event', category, action, label, 1);
            }
        }
    })
    .service('ForgotService', function($http, AmazonUrls, $location, $window, ApiCall, Loader) {
        this.getPassword = function(email) {
            myobject = JSON.stringify({ email: email });
            Loader.show();
            var req = {
                method: 'POST',
                url: AmazonUrls.getUrl('forgotpassword'),
                data: myobject,
                headers: ApiCall.forgotPasswordHeader()
            }
            $http(req).success(function(data, status, headers, config) {
                alert(data['message'])
                if (data['status'])
                    $window.location.href = '#/srlogin';
                Loader.hide();
            }).error(function(data, status, headers, config) {
                // ionicToast.show('Oops there was some problem processing your request. Please check your email or try again later.', 'middle', false, 1000);
                alert('Oops there was some problem processing your request. Please check your email or try again later.')
                Loader.hide();
            })
        }
    })
    .service('TnCService', function($http, AmazonUrls, $q, $location, $window, ApiCall, Loader, ionicToast) {
        this.getTnCStatus = function() {
            var deferred = $q.defer();
            Loader.show();
            var req = {
                method: 'GET',
                url: AmazonUrls.getUrl('termsandcondition'),
                headers: ApiCall.getHeaderAccesskey()
            };
            $http(req).success(function(data, status, headers, config) {
                if (data) {
                    deferred.resolve(data);
                } else {
                    //no network
                    deferred.reject(null);
                }
            }).error(function(data, status, headers, config) {
                deferred.reject(data);
            }).finally(function() {
                Loader.hide();
            });
            return deferred.promise;
        }

        this.changeTnCStatus = function() {
            var deferred = $q.defer();
            Loader.show();
            var req = {
                method: 'POST',
                url: AmazonUrls.getUrl('termsandcondition'),
                headers: ApiCall.getHeaderAccesskey()
            }
            $http(req).success(function(data, status, headers, config) {
                if (data) {
                    deferred.resolve(data);
                } else {
                    //no network
                    deferred.reject(null);
                }
            }).error(function(data, status, headers, config) {
                ionicToast.show('Something went wrong, Please try again.', 'middle', false, 1000);
                deferred.reject(data);
            }).finally(function() {
                Loader.hide();
            });
            return deferred.promise;
        }
    })
    .service('APIInterceptor', function($rootScope, $q) {
        var service = this;
        service.response = function(response) {
            $rootScope.internet = 1;
            return response;
        };
        service.responseError = function(response) {
            if (response.status === -1) {
                $rootScope.internet = 0;
                if (response.config.url.match('kpi.knowlarity'))
                    $rootScope.$broadcast('No_Network');
                return response;
            }
            return $q.reject(response)
        }
    })
    .service('notification', function($window, $q, $http, AuthService, AmazonUrls, JsonToFormdata, _ENV) {
        var self = this, push;
        this.register = function() {
            if (_ENV.PUSH_NOTIFICATIONS_ENABLED && (ionic.Platform.isAndroid() || ionic.Platform.isIOS()) && window.cordova) {
                push = PushNotification.init({
                    "android": {
                    },
                    "ios": {
                        "sound": true,
                        "alert": true,
                        "badge": true
                    },
                    "windows": {}
                });
                push.on("registration", function(data) {
                    self.newRegId = data.registrationId;
                    self.oldRegId = localStorage.getItem("registrationId");
                    if (self.oldRegId !== self.newRegId) {
                        self.registerTokenServer(self.newRegId)
                        .success(function() {
                            localStorage.setItem("registrationId", self.newRegId);
                            console.log("SUCCESS: FCM token saved on localStorage.");
                        })
                    }
                    console.log("SUCCESS: Registration event => " + data.registrationId);
                });
                push.on("notification", function(data) {
                    localStorage.setItem("Notification", data.message);
                    console.log("SUCCESS: Notification event => " + data.message + "" + data.title);
                });
                push.on("error", function(e) {
                    console.log("FAILURE: Notification error => " + e.message);
                });
            }
        }
        this.unRegister = function() {
            if (_ENV.PUSH_NOTIFICATIONS_ENABLED && (ionic.Platform.isAndroid() || ionic.Platform.isIOS()) && window.cordova) {
                var deferred = $q.defer();
                push.unregister(function() {
                    self.unRegisterTokenServer()
                    .success(function() {
                        deferred.resolve();
                    })
                    .error(function() {
                        deferred.reject("FAILURE: Error in unregistering FCM token at app server.");
                    })
                    .finally(function() {
                        localStorage.removeItem("registrationId");
                        console.log("SUCCESS: Removed FCM token from localStorage.");
                    })
                    console.log("SUCCESS: Unregistered FCM token from google's server.");
                }, function() {
                    deferred.reject("FAILURE: Error in unregistering FCM token at google's server.");
                    console.log("FAILURE: Error in unregistering FCM token at google's server.");
                })
                return deferred.promise;
            }else{
                return $q.when();
            }
        }
        this.registerTokenServer = function(t) {
            var req = this.makeRequestObject(AmazonUrls.getUrl("subscribeNotifications"), t),
                _req = $http(req);
            _req
            .success(function(data, status, headers, config) {
                console.log("SUCCESS: FCM token registered on app server.");
            })
            .error(function(data, status, headers, config) {
                console.log("FAILURE: Error in registering FCM token on app server.");
            });
            return _req;
        }
        this.unRegisterTokenServer = function() {
            var t = localStorage.getItem("registrationId"),
                req = this.makeRequestObject(AmazonUrls.getUrl('unSubscribeNotifications'), t),
                _req = $http(req);
            _req
            .success(function(data, status, headers, config) {
                console.log("SUCCESS: FCM token unregistered from app server.");
            })
            .error(function(data, status, headers, config) {
                console.log("FAILURE: Error in unregistering FCM token at app server.");
            });
            return _req;
        }
        this.makeRequestObject = function(url, token) {
            var obj = {},
                iter = AuthService.getUserCredentials();
            obj['api_key'] = iter.api_key;
            if (iter.sr_number.indexOf(',') != -1)
                obj['sr_number'] = iter.sr_number.split(',')[0];
            else
                obj['sr_number'] = iter.sr_number;
            obj['agent_number'] = iter.contact_number;
            obj['registration_id'] = token;
            var req = {
                method: 'POST',
                url: url,
                transformRequest: JsonToFormdata.convert,
                data: obj,
                headers: {
                    'Authorization': "apikey " + iter['userid'] + ":" + iter['api_key'],
                    'x-api-key': 'uHr2kplt4d4YYs4DrZxTmav558YAjk2V1Vdw5HPn',
                    'Content-Type': 'application/x-www-form-urlencoded'
                }
            }
            return req;
        }
    })
    .service('hotCodeReload', function($ionicDeploy, _ENV) {
        this.checkUpdates = function() {
            if (_ENV.HOT_CODE_ENABLED && (ionic.Platform.isAndroid() || ionic.Platform.isIOS()) && window.cordova) {
                $ionicDeploy.channel = _ENV.HOT_CODE_CHANNEL_TAG;
                $ionicDeploy.check().then(function(snapshotAvailable) {
                    if (snapshotAvailable) {
                        $ionicDeploy.download().then(function() {
                            return $ionicDeploy.extract().then(function() {
                                $ionicDeploy.load();
                            });
                        });
                    }
                });
            }
        }
    })
    .service('AppUpdate',function($http, $q, AmazonUrls){
        this.checkAppUpdate = function(){
            if (ionic.Platform.isAndroid() || ionic.Platform.isIOS() && window.cordova) {
                var deferred = $q.defer();
                $http({
                        method: 'GET',
                        url: AmazonUrls.getUrl('checkAppUpdate'),
                        params: {},
                        headers: {
                                'Content-Type': 'application/json' ,
                                'Access-Control-Allow-Origin': '*',
                                'Access-Control-Allow-Methods': 'POST, GET, OPTIONS',
                                'Access-Control-Allow-Headers':'X-Requested-With'
                         }
                    })
                    .success(function(data) {
                        deferred.resolve(data);
                        console.log(JSON.stringify(data));
                    })
                    .error(function(error) {
                        deferred.reject(error);
                    }).finally(function() {});
                return deferred.promise;
            }           
        }    
    })
    .service('nativeStorage', function($cordovaNativeStorage, AuthService) {
        var self = this;
        this.sync = function() {
            if ((ionic.Platform.isAndroid() || ionic.Platform.isIOS()) && window.cordova) {
                var userDataPromise = AuthService.getUserCredentialsWithPromise();
                userDataPromise.then(function(userData){
                var api_key = userData['api_key'] || 'null',
                    user_id =  userData['user_id'] || 0,
                    user_name =  userData['userid'] || 'null',
                    record_sync_mobile_calls = userData['record_sync_mobile_calls'] || 'false'
                    contact_number = userData['contact_number'] || 'null',
                    sr_number = userData.sr_number || 'null',
                    userplatform = userData['userplatform'] || 'null',
                    device_model = userData['device_model'] || 'null';

                    $cordovaNativeStorage.setItem("api_key", api_key).then(function(value) {
                        console.log(value);
                        $cordovaNativeStorage.getItem("api_key").then(function (value) {
                            console.log(value);
                        }, function (error) {
                            console.log(error);
                        });
                    }, function (error){
                        console.log(error);
                    })

                    $cordovaNativeStorage.setItem("user_id", user_id).then(function(value) {
                        console.log(value);
                        $cordovaNativeStorage.getItem("user_id").then(function (value) {
                            console.log(value);
                        }, function (error) {
                            console.log(error);
                        });
                    }, function (error){
                        console.log(error);
                    })

                    $cordovaNativeStorage.setItem("user_name", user_name).then(function(value) {
                        console.log(value);
                        $cordovaNativeStorage.getItem("user_name").then(function (value) {
                            console.log(value);
                        }, function (error) {
                            console.log(error);
                        });
                    }, function (error){
                        console.log(error);
                    })

                    $cordovaNativeStorage.setItem("contact_number", contact_number).then(function(value) {
                         console.log(value);
                         $cordovaNativeStorage.getItem("contact_number").then(function (value) {
                             console.log(value);
                         }, function (error) {
                             console.log(error);
                         });
                    }, function (error){
                         console.log(error);
                    })

                    $cordovaNativeStorage.setItem("sr_number", sr_number).then(function(value) {
                          console.log(value);
                          $cordovaNativeStorage.getItem("sr_number").then(function (value) {
                              console.log(value);
                          }, function (error) {
                              console.log(error);
                          });
                    }, function (error){
                          console.log(error);
                    })

                    $cordovaNativeStorage.setItem("userplatform", userplatform).then(function(value) {
                          console.log(value);
                          $cordovaNativeStorage.getItem("userplatform").then(function (value) {
                              console.log(value);
                          }, function (error) {
                              console.log(error);
                          });
                    }, function (error){
                          console.log(error);
                    })

                    $cordovaNativeStorage.setItem("device_model", device_model).then(function(value) {
                          console.log(value);
                          $cordovaNativeStorage.getItem("device_model").then(function (value) {
                              console.log(value);
                          }, function (error) {
                              console.log(error);
                          });
                    }, function (error){
                          console.log(error);
                    })

                    console.log("changeSettings : calling function :"+record_sync_mobile_calls);
                    self.changeSettings(record_sync_mobile_calls)
                });

            }
        }
        this.changeSettings = function(record_sync_mobile_calls){
            console.log("changeSettings : function called with value :"+record_sync_mobile_calls);
            $cordovaNativeStorage.setItem("record_sync_mobile_calls", record_sync_mobile_calls).then(function(value) {
                        console.log(value);
                        $cordovaNativeStorage.getItem("record_sync_mobile_calls").then(function (value) {
                            console.log(value);
                        }, function (error) {
                            console.log(error);
                        });
                    }, function (error){
                        console.log(error);
                    })
        }
        this.removeKeys = function() {
            console.log("removeKeys Called");
            if ((ionic.Platform.isAndroid() || ionic.Platform.isIOS()) && window.cordova) {
            $cordovaNativeStorage.remove("api_key").then(function(value) {
                        //success
                    }, function (error){
                        console.log(error);
                    })
                    $cordovaNativeStorage.remove("record_sync_mobile_calls").then(function(value) {
                        //success
                    }, function (error){
                        console.log(error);
                    })
                    $cordovaNativeStorage.remove("user_id").then(function(value) {
                        //success
                    }, function (error){
                        console.log(error);
                    })
            }
        }
    })
    .service('resetPasswordService', function($http, $q, AmazonUrls) {
        this.reset = function(uidb36, token, data) {
            var deferred = $q.defer(),
                url = AmazonUrls.getUrl('resetpassword') + '?uidb36=' + uidb36 + '&token=' + token;
            $http({
                    method: 'POST',
                    url: url,
                    transformRequest: function(obj) {
                        var str = [];
                        for(var p in obj)
                        str.push(encodeURIComponent(p) + "=" + encodeURIComponent(obj[p]));
                        return str.join("&");
                    },
                    headers: {
                        'x-api-key': 'uHr2kplt4d4YYs4DrZxTmav558YAjk2V1Vdw5HPn',
                        'Content-Type': 'application/x-www-form-urlencoded'
                    },
                    data: data
                })
                .success(function(data) {
                    if(data){
                        deferred.resolve({
                            response: data
                        });
                    }else {
                        deferred.reject(null);
                    }
                })
                .error(function(msg, code) {
                    deferred.reject(msg);
                })
            return deferred.promise;
        }
    })

    .service('PhonebookContact',function($q,$cordovaContacts){
        this.pickContact =function(){
            var q = $q.defer();
            
            navigator.contacts.pickContact(function (contact) {
                console.log("pick Contact success function is called "+JSON.stringify(contact));
                q.resolve(contact);
            }, function (err) {
                console.log("pick Contact failure function is called");
              q.reject(err);
            });

            return q.promise;
        }
    })